/*
Sonic Rainbow written by Gary Baker South Australia.
Copyright (C) 2003 Gary Baker

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include <stdio.h>
#include <stdlib.h>
#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "cd.h"
#include <fcntl.h>
#include <linux/soundcard.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <linux/videodev.h>
#include <string.h>

extern int which_player;

extern int cd_handle,completed;
extern int disk_present;
extern int sel_tracks[100];
extern char default_mixer[1000];
extern int display_radio;
extern int radio_dev;
extern struct video_audio va;
extern struct video_tuner vt;

int destroy;
int hwstat=0;
int rip_timer;
int canrip;
int global_exit=0;

GtkWidget *cd_entry;
GtkWidget *hw=NULL;
GtkWidget *setw=NULL;
GtkWidget *ripw=NULL;

extern guint cd_timer;
extern GtkWidget *rlist_item,*freq_spin;
extern GtkWidget *rip_list;
extern float frequencys[11];
extern char  blabels[11][7];

int play_cdauto();
int ripper_cd();
void free_list();
void main_vol( GtkAdjustment *get, gpointer         user_data );
void main_bal( GtkAdjustment *get, gpointer         user_data );
void main_f( GtkAdjustment *get, gpointer         user_data );
void xstuff();

void show_cdplayer();
void hide_cdplayer();
void show_oggplayer();
void hide_oggplayer();
void hide_videoplayer();
void show_videoplayer();
void main_f( GtkAdjustment *get, gpointer         user_data );
void hide_radioplayer();
void show_radioplayer();
void reset_radio_button(int but);
void load_player(int);


GtkTooltips *stip;

GtkWidget *mvol,*mwin,*mbal,*sta,*main_fixed,*et;
GtkObject *madj,*mbadj,*sadj;
void radio_buttons();
void do_save_config();
void do_error_message(char *text);

typedef struct _cd_track
{
int tracknum;
char *title;
char *artist;
int length;
}cd_tracks;

extern   struct rcds
{
int tracks;
char *title;
char *artist;
char *genre;
cd_tracks c_tracks[100];
}rcd_info;

extern struct cds
{
int tracks;
char *title;
char *artist;
char *genre;
cd_tracks c_tracks[100];
}cd_info;


int cancdda,canogg,canmp3;

extern int frames[100];


union
{
int x;
char l[2];
}vbal;



void
on_main_window_exit_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
global_exit=1;
stop_cd(cd_handle);
if(radio_dev>0)
{
frequencys[10]=gtk_spin_button_get_value_as_float((GtkSpinButton*)freq_spin);
va.audio = 0;
va.volume = 0;
va.flags = VIDEO_AUDIO_MUTE;
ioctl(radio_dev, VIDIOCSAUDIO, &va);

close(radio_dev);
radio_dev=-1;
}
do_save_config();
gtk_main_quit();
}


void
on_main_window_destroy                 (GtkObject       *object,
                                        gpointer         user_data)
{
 stop_cd(cd_handle);
 gtk_main_quit();
}



void
on_main_window_setup_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{

if(setw==NULL)
{
 destroy=0;

 setw=create_setup_window();
 gtk_widget_show (setw);
 gtk_main();
 if(destroy==0 || destroy==2)
 {
 gtk_widget_destroy(setw);
 setw=NULL;
 }
}

}







void
on_main_window_rip_cd_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
int num;
FILE *po=NULL;
char b[500];
FILE *fptr=NULL;
char *ebuff;

po=popen("which cdda2wav","r");
fgets(b,499,po);
pclose(po);
b[strlen(b)-1]=0;
fptr=fopen(b,"r");
if(fptr==NULL)
cancdda=0;
else
{
cancdda=1;
fclose(fptr);
}

po=popen("which oggenc","r");
fgets(b,499,po);
pclose(po);
b[strlen(b)-1]=0;
fptr=fopen(b,"r");
if(fptr==NULL)
canogg=0;
else
{
canogg=1;
fclose(fptr);
}


po=popen("which lame","r");
fgets(b,499,po);
pclose(po);
b[strlen(b)-1]=0;
fptr=fopen(b,"r");
if(fptr==NULL)
canmp3=0;
else
{
canmp3=1;
fclose(fptr);
}

if(!cancdda || ! canmp3 || !canogg)
{
  ebuff=(char *)malloc(5000);
  ebuff[0]=0;
  if(!cancdda)
  strcat(ebuff,"cdda2wav cannot be found. The ripper\nWindow will still execute but ripping\nwill be disabled.");
if(!canogg)
  strcat(ebuff,"\noggenc cannot be found. The ripper\nWindow will still execute but ripping\nto Ogg format will be disabled.");
if(!canmp3)
  strcat(ebuff,"\nlame cannot be found. The ripper\nWindow will still execute but ripping\nto mp3 format will be disabled.");
   do_error_message(ebuff);
   free(ebuff);
   canrip=0;
}
else
canrip=1;

if(ripw==NULL)
{
for(num=0;num<100;num++)
{
rcd_info.c_tracks[num].title=NULL;
rcd_info.c_tracks[num].artist=NULL;
sel_tracks[num]=0;
}


rcd_info.title=NULL;
rcd_info.artist=NULL;
rcd_info.genre=NULL;
rcd_info.tracks=0;
rlist_item=NULL;

rip_list=NULL;

ripw=create_ripper_window();
gtk_widget_show (ripw);
 rip_timer=gtk_timeout_add(250,ripper_cd,NULL);
}

}





void
on_help_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
 if(hwstat==0)
 {
  hwstat=1;
 hw=create_help_window();
 gtk_widget_show(hw);
 gtk_main();
 gtk_widget_destroy(hw);
  }
 }


void
on_help_ok_button_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
hwstat=0;
gtk_main_quit();
}

char help[10000];


void
on_help_text_box_realize               (GtkWidget       *widget,
                                        gpointer         user_data)
{
strcpy(help,"Sonic-Rainbow Version 0.3.5\nCopyright Gary Baker\n");
strcat(help,"\nExtensive Help is available in the file\n/usr/share/Sonic-Rainbow/doc/Sonic-Rainbow.html\nThis file can be viewed in any Web Browser\n");

gtk_text_insert((GtkText*)widget,NULL,NULL,NULL,help,-1);

}






void
on_main_window_fixed_realize           (GtkWidget       *widget,
                                        gpointer         user_data)
{

int a,f;

main_fixed=widget;
xstuff();

load_player(which_player);

radio_buttons();

/*
if(display_radio)
show_radio();
*/
    f=open(default_mixer,O_RDONLY);

    ioctl(f,MIXER_READ(SOUND_MIXER_VOLUME),&a);
    close(f);

    a=a>>8;
    a=a/10;


  madj=gtk_adjustment_new (a, 0, 10, 1, 0, 0);
  mvol= gtk_hscale_new (GTK_ADJUSTMENT (madj));
  gtk_widget_ref (mvol);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vscale1", mvol,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mvol);
  gtk_fixed_put (GTK_FIXED (widget), mvol, 16,157);
  gtk_widget_set_uposition (mvol,16,157);
  gtk_widget_set_usize (mvol,100,24);
  gtk_scale_set_draw_value (GTK_SCALE (mvol), FALSE);

  gtk_signal_connect (GTK_OBJECT (madj), "value_changed",
                        GTK_SIGNAL_FUNC (main_vol), NULL);

}


void
on_main_window_realize                 (GtkWidget       *widget,
                                        gpointer         user_data)
{

GtkTargetEntry target_entry[1];

target_entry[0].target="text/plain";
target_entry[0].flags=0;
target_entry[0].info=0;

gtk_drag_dest_set(widget,GTK_DEST_DEFAULT_MOTION | GTK_DEST_DEFAULT_HIGHLIGHT | GTK_DEST_DEFAULT_DROP,
target_entry,sizeof(target_entry)/sizeof(GtkTargetEntry),GDK_ACTION_COPY|GDK_ACTION_MOVE);

mwin=widget;
}

void main_vol( GtkAdjustment *get, gpointer         user_data )
{
int f=0;
static int b=0;
char *ebuff;

    f=open(default_mixer,O_RDONLY);

    if(f==-1)
{


if(b==0)
{
  ebuff=(char *)malloc(5000);
strcpy(ebuff,"Errors accesing the Mixer Device\nSonic-Rainbow needs to be able to read and write\nto the Mixer device file to alter the Volume.\nYour Mixer device has been configured as \n");
strcat(ebuff,default_mixer);
strcat(ebuff,"\nThis may be a file permissions based\nproblem that can be resolved by changing the\npermissions on ");
strcat(ebuff,default_mixer);
strcat(ebuff,"\nor changing the runtime permissions of\nSonic-Rainbow\nThis Error message will not be redisplayed.");
   do_error_message(ebuff);
   free(ebuff);
   b=1;
}
   return;
}



    b=(int)get->value;
    b=b*10;
    b=(b | (b << 8));
    ioctl(f,MIXER_WRITE(SOUND_MIXER_VOLUME),&b);
    close(f);

  }


void main_bal( GtkAdjustment *get, gpointer         user_data )
{
int f,b;

    f=open(default_mixer,O_RDONLY);
    b=(int)get->value;
    b=b*10;
    b=(b | (b << 8));
    ioctl(f,MIXER_WRITE(SOUND_MIXER_VOLUME),&b);
    close(f);
}



void do_error_message(char *text)
{
GtkWidget *em;
   em=create_error_window();
   gtk_widget_show(em);
   gtk_text_insert((GtkText*)et,NULL,NULL,NULL,text,-1);
   gtk_main();
   gtk_widget_destroy(em);
}


void
on_error_ok_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_main_quit();
}


void
on_error_text_realize                  (GtkWidget       *widget,
                                        gpointer         user_data)
{
et=widget;
}




void
on_cd_player_button_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
load_player(1);
}


void
on_ogg_player_button_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
load_player(2);
}


void
on_dvd_player_button_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
load_player(3);
}


void
on_radio_player_button_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
load_player(4);
}


void load_player(int w)
{
void show_cdplayer();
void hide_cdplayer();
void show_oggplayer();
void hide_videoplayer();
void main_f( GtkAdjustment *get, gpointer         user_data );
void hide_radioplayer();
void show_radioplayer();
void reset_radio_button(int but);

if(which_player)
{
 if(which_player==1)
 hide_cdplayer();
 else
 if(which_player==2)
 hide_oggplayer();
 else
 if(which_player==3)
 hide_videoplayer();
 else
 if(which_player==4)
 hide_radioplayer();
}

 if(w==1)
 show_cdplayer();
 else
 if(w==2)
 show_oggplayer();
 else
 if(w==3)
 show_videoplayer();
 else
 if(w==4)
 show_radioplayer();
 
which_player=w;



}







