/*
Sonic Rainbow written by Gary Baker South Australia.
Copyright (C) 2003 Gary Baker
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Sonic Rainbow (c) 2003-2010 Gary Baker http://ozscap.sourceforge.net
*/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <gtk/gtk.h>
#include <cddb/cddb.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <linux/cdrom.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/stat.h>

#include "cddev.h"
#include "cd.h"
#include "interface.h"


#define ENV_HTTP_PROXY "http_proxy"
#define HTTP_PREFIX "http://"
#define HTTP_PREFIX_LEN 7

extern char *cats[];/*={"soundtrack","rock","jazz","misc","country","blues","newage","reggae","classical","folk"};*/
extern guint cd_timer;
extern char *music_dir,*cd_dev;
extern int rip_timer;
extern int canrip;
extern int http_lookup;
extern int cancdda,canogg,canmp3;

int get_disc_id();
unsigned int cddb_sum(int n);
void do_display(cddb_disc_t *disc);
void bizzo();
int get_disc_id();
unsigned int cddb_sum(int n);
void do_display(cddb_disc_t *disc);
int rfile_read();
int ripper_cd();
void list_disc();
void rfree_list();
void fill_list(char []);
void free_list();
void rfill_list(char buffer[],int );
int list_from_net(cddb_disc_t *disc);
int rfgets(FILE *fptr,char *b);
void on_rippper_window_ripsel_clicked       (GtkButton       *button,
                                        gpointer         user_data);
/*g_list_free */
void do_error_message(char *text);
void do_ripcd(void);
void up_ripcd();

extern int cd_handle,completed;
extern int cd_autoplay,cddb;
extern char *cd_dev;
extern GtkWidget *cd_entry;
extern GtkWidget *ripw;

GtkWidget *progressbar1;
GtkWidget *rip_list,*cdtitle_entry,*cdartist_entry,*cdgenre_entry,*cdyear_spin;
GtkWidget *trackname_entry,*trackartist_entry;
GtkWidget *rip_fixed,*rip_win,*music_direntry,*ogg_form,*wav_form;
GtkWidget *exit_clicked,*cancel_clicked,*ripsel_clicked,*ripcd_clicked;
int stop_rip;
int ignore=0;
int my_idle;

int play_cdauto();
int disk_present=0;
int rselnum=-1;
int sel_tracks[100];
int pt=0;

struct stat st;

void
on_ripper_window_track_title_entry_changed
                                        (GtkEditable     *editable,
                                        gpointer         user_data);
char l[1000];
GtkWidget *rlist_item=NULL;
int prog;

typedef struct _cd_track
{
int tracknum;
char *title;
char *artist;
int length;
}cd_tracks;

struct rcds
{
int tracks;
char *title;
char *artist;
char *genre;
cd_tracks c_tracks[100];
}rcd_info;


int frames[100];
int disc_time;
unsigned int disc_tracks;





void
on_ripper_window_exit_realize          (GtkWidget       *widget,
                                        gpointer         user_data)
{
exit_clicked=widget;
}


void
on_ripper_window_cancel_realize        (GtkWidget       *widget,
                                        gpointer         user_data)
{
cancel_clicked=widget;
}


void
on_ripper_window_ripcd_realize         (GtkWidget       *widget,
                                        gpointer         user_data)
{
if(!cancdda)
gtk_widget_set_sensitive (widget, FALSE);
if(!canmp3 && !canogg)
gtk_widget_set_sensitive (widget, FALSE);
ripcd_clicked=widget;
}


void
on_rippper_window_ripsel_realize       (GtkWidget       *widget,
                                        gpointer         user_data)
{
if(!cancdda)
gtk_widget_set_sensitive (widget, FALSE);
if(!canmp3 && !canogg)
gtk_widget_set_sensitive (widget, FALSE);
ripsel_clicked=widget;
}









void
on_cdripper_list_select_row            (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
gtk_signal_handler_block_by_func((GtkObject *)trackname_entry,on_ripper_window_track_title_entry_changed,NULL);
rselnum=row;
gtk_entry_set_text((GtkEntry *)trackname_entry,rcd_info.c_tracks[rselnum].title);
gtk_entry_set_text((GtkEntry *)trackartist_entry,rcd_info.c_tracks[rselnum].artist);
sel_tracks[rselnum]=1;
gtk_signal_handler_unblock_by_func((GtkObject*)trackname_entry,on_ripper_window_track_title_entry_changed,NULL);
}


void
on_cdripper_list_unselect_row          (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
rselnum=row;
sel_tracks[rselnum]=0;
}


void
on_cdripper_list_realize               (GtkWidget       *widget,
                                        gpointer         user_data)
{
if(disk_present==0)disk_present=-1;
rip_list=widget;
}



void
on_ripper_window_track_title_entry_changed
                                        (GtkEditable     *editable,
                                        gpointer         user_data)
{
char *b;
char nbuff[1000];

b=gtk_entry_get_text((GtkEntry *)trackname_entry);
free(rcd_info.c_tracks[rselnum].title);
rcd_info.c_tracks[rselnum].title=(char*)malloc(strlen(b)+1);
strcpy(rcd_info.c_tracks[rselnum].title,b);
sprintf(nbuff,"%d ",rselnum+1);
strcat(nbuff,b);
gtk_clist_set_text((GtkCList*)rip_list,rselnum,0,nbuff);
}

void
on_ripper_window_track_artist_entry_changed
                                        (GtkEditable     *editable,
                                        gpointer         user_data)
{
char *b;
char nbuff[1000];

b=gtk_entry_get_text((GtkEntry *)trackartist_entry);
free(rcd_info.c_tracks[rselnum].artist);
rcd_info.c_tracks[rselnum].artist=(char*)malloc(strlen(b)+1);
strcpy(rcd_info.c_tracks[rselnum].artist,b);
strcpy(nbuff,b);
gtk_clist_set_text((GtkCList*)rip_list,rselnum,1,nbuff);
}



void
on_fixed1_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
rip_fixed=widget;
ignore=0;
pt=0;
}

void
on_ripper_window_artist_entry_realize  (GtkWidget       *widget,
                                        gpointer         user_data)
{
cdartist_entry=widget;
}

void
on_ripper_window_realize               (GtkWidget       *widget,
                                        gpointer         user_data)
{
rip_win=widget;
}



void
on_ripper_window_exit_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
int num;
disk_present=0;

stop_rip=1;


gtk_clist_clear((GtkCList*)rip_list);

for(num=0;num<100;num++)
{
free(rcd_info.c_tracks[num].title);
free(rcd_info.c_tracks[num].artist);
rcd_info.c_tracks[num].title=NULL;
rcd_info.c_tracks[num].artist=NULL;
}


free(rcd_info.title);
free(rcd_info.artist);
free(rcd_info.genre);
rcd_info.title=NULL;
rcd_info.artist=NULL;
rcd_info.genre=NULL;


gtk_timeout_remove(rip_timer);
pt=0;
 disk_present=0;

 gtk_widget_destroy(ripw);

if(ripw!=NULL)
 ripw=NULL;


}


void
on_ripper_window_cancel_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
stop_rip=1;
}






void
on_ripper_window_ripcd_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{

if(pt==0)
{
pt=1;
do_ripcd();
}


}



void do_ripcd(void)
{

 int count,perc;
 char buff[1000],b[1000],tbuff[1000];
 char mdir[1000];
 static int d=0;
 FILE *fptr;
 char *token;
 int lfc,mfc;

 if(ignore==1)return;
 ignore=1;

 strcpy(mdir,gtk_entry_get_text((GtkEntry *)music_direntry));
 mkdir(mdir,S_IRWXU|S_IRWXG|S_IRWXO);
 strcat(mdir,"/");
 strcat(mdir,rcd_info.artist);
 mkdir(mdir,S_IRWXU|S_IRWXG|S_IRWXO);
 strcat(mdir,"/");
 strcat(mdir,rcd_info.title);
 mkdir(mdir,S_IRWXU|S_IRWXG|S_IRWXO);
 strcat(mdir,"/");

  progressbar1 = gtk_progress_bar_new ();
  gtk_widget_ref (progressbar1);
  gtk_object_set_data_full (GTK_OBJECT (rip_win), "progressbar1", progressbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (progressbar1);
  gtk_fixed_put (GTK_FIXED (rip_fixed), progressbar1, 170, 220);
  gtk_widget_set_uposition (progressbar1, 170, 220);
  gtk_widget_set_usize (progressbar1, 150, 20);
  gtk_progress_set_show_text (GTK_PROGRESS (progressbar1), TRUE);


gtk_entry_set_editable((GtkEntry*)music_direntry,FALSE);
gtk_entry_set_editable((GtkEntry*)cdtitle_entry,FALSE);
gtk_entry_set_editable((GtkEntry*)cdartist_entry,FALSE);
gtk_entry_set_editable((GtkEntry*)trackname_entry,FALSE);
gtk_entry_set_editable((GtkEntry*)trackartist_entry,FALSE);
gtk_entry_set_editable((GtkEntry*)music_direntry,FALSE);
gtk_entry_set_editable((GtkEntry*)cdgenre_entry,FALSE);
gtk_signal_handler_block_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_select_row),NULL);
gtk_signal_handler_block_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_unselect_row),NULL);
gtk_signal_handler_block_by_func(GTK_OBJECT (exit_clicked),GTK_SIGNAL_FUNC (on_ripper_window_exit_clicked),NULL);
gtk_signal_handler_block_by_func(GTK_OBJECT (ripcd_clicked),GTK_SIGNAL_FUNC (on_ripper_window_ripcd_clicked),NULL);
gtk_signal_handler_block_by_func(GTK_OBJECT (ripsel_clicked),GTK_SIGNAL_FUNC (on_rippper_window_ripsel_clicked),NULL);
while (gtk_events_pending ())
       gtk_main_iteration_do(FALSE);

       
gtk_timeout_remove(cd_timer);
for(count=0;count<rcd_info.tracks;count++) /* outer for loop */
gtk_clist_set_text((GtkCList*)rip_list,count,2,"");


for(count=0;count<rcd_info.tracks;count++) /* outer for loop */
{

sprintf(buff,"cdda2wav -D%s -O wav -t%d -g -H -x  \"%s/track%.2d.wav\" 2>&1",cd_dev,count+1,mdir,count+1);
gtk_clist_set_text((GtkCList*)rip_list,count,2,"Ripping");
fptr=popen(buff,"r");

stop_rip=0;


while(1)
{
if(stop_rip==1)break;
token=fgets(buff,100,fptr);
if(token==NULL)break;
strcpy(b,buff);
if(buff[strlen(buff)-1]=='\r')
{
buff[strlen(buff)-2]=0;
token=strtok(buff,"%%");
token=strtok(NULL," ");
token=strtok(NULL," ");
token=strtok(NULL," ");
token=strtok(NULL," ");
token=strtok(NULL," ");
token=strtok(NULL,"%%");
gtk_progress_set_value(GTK_PROGRESS(progressbar1),atoi(token));
while (gtk_events_pending ())
       gtk_main_iteration_do(FALSE);

}

while (gtk_events_pending ())
       gtk_main_iteration_do(FALSE);

if(stop_rip==1)break;
}

pclose(fptr);

if(stop_rip==1)break;

gtk_clist_set_text((GtkCList*)rip_list,count,2,"Ripped");
if(gtk_toggle_button_get_active((GtkToggleButton*)wav_form))
gtk_clist_set_text((GtkCList*)rip_list,count,2,"Finished");

while (gtk_events_pending ())
       gtk_main_iteration_do(FALSE);

if(stop_rip==1)break;
}  /* for tracks */

while (gtk_events_pending ())
       gtk_main_iteration_do(FALSE);


if(gtk_toggle_button_get_active((GtkToggleButton*)wav_form))
{
gtk_widget_destroy(progressbar1);

gtk_entry_set_editable((GtkEntry*)music_direntry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdtitle_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdartist_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)trackname_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)trackartist_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)music_direntry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdgenre_entry,FALSE);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_select_row),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_unselect_row),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (exit_clicked),GTK_SIGNAL_FUNC (on_ripper_window_exit_clicked),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (ripcd_clicked),GTK_SIGNAL_FUNC (on_ripper_window_ripcd_clicked),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (ripsel_clicked),GTK_SIGNAL_FUNC (on_rippper_window_ripsel_clicked),NULL);

gtk_clist_unselect_all((GtkCList*)rip_list);
cd_timer=gtk_timeout_add(250,play_cdauto,NULL);
ignore=0;
stop_rip=0;
pt=0;
d=0;
return;
}




if(stop_rip==0) /* stop rip */
{
if(gtk_toggle_button_get_active((GtkToggleButton*)ogg_form))
{
for(count=0;count<rcd_info.tracks;count++) /* outer for loop */
{

sprintf(buff,"oggenc \"-q 10\" \"-a%s \" \"-t%s \" \"-l%s \" \"-G%s \" \"%s/track%.2d.wav\" 2>&1",rcd_info.c_tracks[count].artist,rcd_info.c_tracks[count].title,rcd_info.title,rcd_info.genre,mdir,count+1);
fptr=popen(buff,"r");
gtk_clist_set_text((GtkCList*)rip_list,count,2,"Encoding");
perc=0;

while(1)
{
 if(rfgets(fptr,buff)==0)
 break;

 if(perc==1)
 {
  token=strtok(buff,"[");
  if(token!=NULL)
  token=strtok(NULL,"%%");
  if(token!=NULL)
  gtk_progress_set_value(GTK_PROGRESS(progressbar1),atoi(token));
  while (gtk_events_pending ())
       gtk_main_iteration_do(FALSE);
  }
  else
  if(strncmp(buff,"at",2)==0)perc=1;

  if(stop_rip==1)break;
  while (gtk_events_pending ())
       gtk_main_iteration_do(FALSE);
}

pclose(fptr);

gtk_clist_set_text((GtkCList*)rip_list,count,2,"Finished");
sprintf(buff,"%s/track%.2d.wav",mdir,count+1);
unlink(buff);
if(stop_rip==1)break;
}
}
else   /* rip mp3 */
{
 for(count=0;count<rcd_info.tracks;count++) /* outer for loop */
 {
if(strlen(rcd_info.c_tracks[count].title)>30)
rcd_info.c_tracks[count].title[30]=0;

if(strlen(rcd_info.title)>30)
rcd_info.title[30]=0;

if(strlen(rcd_info.c_tracks[count].artist)>30)
rcd_info.c_tracks[count].artist[30]=0;

  sprintf(buff,"lame -h --tt \"%s\" --tl \"%s\" --ta \"%s\" \"%s/track%.2d.wav\" \"%s/track%.2d.mp3\" 2>&1",rcd_info.c_tracks[count].title,rcd_info.title,rcd_info.c_tracks[count].artist, mdir,count+1,mdir,count+1);
  fptr=popen(buff,"r");
  gtk_clist_set_text((GtkCList*)rip_list,count,2,"Encoding");
  perc=0;

lfc=0;
mfc=0;

   while(1)
  {
mfc++;

   /*if(rfgets(fptr,buff)==0)*/
   if((fgets(buff,100,fptr))==NULL)
   break;

   if(mfc>10)
   {
    strcpy(tbuff,buff);
    if((token=strtok(tbuff,"("))!=NULL)
    {
    if((token=strtok(NULL,"\%"))!=NULL)
     lfc=atoi(token);
        if(lfc>0 && lfc <100)
    gtk_progress_set_value(GTK_PROGRESS(progressbar1),lfc);
    }

   }
      while (gtk_events_pending ())
       gtk_main_iteration_do (FALSE);
   if(stop_rip==1)break;

  }

  pclose(fptr);
  gtk_clist_set_text((GtkCList*)rip_list,count,2,"Finished");
  sprintf(buff,"%s/track%.2d.wav",mdir,count+1);
  unlink(buff);
  if(stop_rip==1)break;
 }
}

} /* stop rip */


gtk_widget_destroy(progressbar1);

gtk_entry_set_editable((GtkEntry*)music_direntry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdtitle_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdartist_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)trackname_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)trackartist_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)music_direntry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdgenre_entry,FALSE);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_select_row),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_unselect_row),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (exit_clicked),GTK_SIGNAL_FUNC (on_ripper_window_exit_clicked),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (ripcd_clicked),GTK_SIGNAL_FUNC (on_ripper_window_ripcd_clicked),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (ripsel_clicked),GTK_SIGNAL_FUNC (on_rippper_window_ripsel_clicked),NULL);

gtk_clist_unselect_all((GtkCList*)rip_list);
cd_timer=gtk_timeout_add(250,play_cdauto,NULL);
ignore=0;
stop_rip=0;
pt=0;
d=0;
}







int rfgets(FILE *fptr,char *b)
{
int num,n=0;


for(num=0;num<100;num++)
{
if(stop_rip==1)break;
n=fread(b+num,sizeof(char),1,fptr);
if(n==0)break;
if(b[num]=='\r')break;
if(b[num]=='\n')break;
}
b[num]=0;
return n;
}




void
on_rippper_window_ripsel_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
 GtkWidget *progressbar1;
 int count,perc;
 char buff[1000],b[1000],mdir[1000];
 FILE *fptr=NULL;
 char *token=NULL;
 int mfc=0;
 int lfc=0;
 char tbuff[1000];

 if(ignore==1)return;
 ignore=1;



 strcpy(mdir,gtk_entry_get_text((GtkEntry *)music_direntry));
 mkdir(mdir,S_IRWXU|S_IRWXG|S_IRWXO);
 strcat(mdir,"/");
 strcat(mdir,rcd_info.artist);
 mkdir(mdir,S_IRWXU|S_IRWXG|S_IRWXO);
 strcat(mdir,"/");
 strcat(mdir,rcd_info.title);
 mkdir(mdir,S_IRWXU|S_IRWXG|S_IRWXO);
 strcat(mdir,"/");

  progressbar1 = gtk_progress_bar_new ();
  gtk_widget_ref (progressbar1);
  gtk_object_set_data_full (GTK_OBJECT (rip_win), "progressbar1", progressbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (progressbar1);
  gtk_fixed_put (GTK_FIXED (rip_fixed), progressbar1, 170, 220);
  gtk_widget_set_uposition (progressbar1, 170, 220);
  gtk_widget_set_usize (progressbar1, 150, 20);
  gtk_progress_set_show_text (GTK_PROGRESS (progressbar1), TRUE);

gtk_timeout_remove(cd_timer);

gtk_entry_set_editable((GtkEntry*)music_direntry,FALSE);
gtk_entry_set_editable((GtkEntry*)cdtitle_entry,FALSE);
gtk_entry_set_editable((GtkEntry*)cdartist_entry,FALSE);
gtk_entry_set_editable((GtkEntry*)trackname_entry,FALSE);
gtk_entry_set_editable((GtkEntry*)trackartist_entry,FALSE);
gtk_entry_set_editable((GtkEntry*)music_direntry,FALSE);
gtk_entry_set_editable((GtkEntry*)cdgenre_entry,FALSE);
gtk_signal_handler_block_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_select_row),NULL);
gtk_signal_handler_block_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_unselect_row),NULL);
gtk_signal_handler_block_by_func(GTK_OBJECT (exit_clicked),GTK_SIGNAL_FUNC (on_ripper_window_exit_clicked),NULL);
gtk_signal_handler_block_by_func(GTK_OBJECT (ripcd_clicked),GTK_SIGNAL_FUNC (on_ripper_window_ripcd_clicked),NULL);
gtk_signal_handler_block_by_func(GTK_OBJECT (ripsel_clicked),GTK_SIGNAL_FUNC (on_rippper_window_ripsel_clicked),NULL);


for(count=0;count<rcd_info.tracks;count++) /* outer for loop */
gtk_clist_set_text((GtkCList*)rip_list,count,2,"");



for(count=0;count<rcd_info.tracks;count++) /* outer for loop */
{
if(sel_tracks[count]!=1)continue;
sprintf(buff,"cdda2wav -D%s -O wav -t%d -g -H -x  \"%s/track%.2d.wav\" 2>&1",cd_dev,count+1,mdir,count+1);

gtk_clist_set_text((GtkCList*)rip_list,count,2,"Ripping");
fptr=popen(buff,"r");

stop_rip=0;

while(1)
{
if(stop_rip==1)break;
token=fgets(buff,100,fptr);
if(token==NULL)break;
strcpy(b,buff);
if(buff[strlen(buff)-1]=='\r')
{
buff[strlen(buff)-2]=0;
token=strtok(buff,"%%");
token=strtok(NULL," ");
token=strtok(NULL," ");
token=strtok(NULL," ");
token=strtok(NULL," ");
token=strtok(NULL," ");
token=strtok(NULL,"%%");
gtk_progress_set_value(GTK_PROGRESS(progressbar1),atoi(token));
}

while (gtk_events_pending ())
       gtk_main_iteration_do (FALSE);
if(stop_rip==1)break;
}

pclose(fptr);

gtk_clist_set_text((GtkCList*)rip_list,count,2,"Ripped");
if(gtk_toggle_button_get_active((GtkToggleButton*)wav_form))
gtk_clist_set_text((GtkCList*)rip_list,count,2,"Finished");

if(stop_rip==1)break;
}  /* for tracks */


if(gtk_toggle_button_get_active((GtkToggleButton*)wav_form))
{
gtk_widget_destroy(progressbar1);



gtk_entry_set_editable((GtkEntry*)music_direntry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdtitle_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdartist_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)trackname_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)trackartist_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)music_direntry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdgenre_entry,FALSE);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_select_row),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_unselect_row),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (exit_clicked),GTK_SIGNAL_FUNC (on_ripper_window_exit_clicked),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (ripcd_clicked),GTK_SIGNAL_FUNC (on_ripper_window_ripcd_clicked),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (ripsel_clicked),GTK_SIGNAL_FUNC (on_rippper_window_ripsel_clicked),NULL);
gtk_clist_unselect_all((GtkCList*)rip_list);

cd_timer=gtk_timeout_add(250,play_cdauto,NULL);

ignore=0;
return;
}





if(stop_rip==0) /* stop rip */
{
if(gtk_toggle_button_get_active((GtkToggleButton*)ogg_form))
{
 for(count=0;count<rcd_info.tracks;count++) /* outer for loop */
 {
  sprintf(buff,"oggenc \"-q 10\" \"-a%s \" \"-t%s \" \"-l%s \" \"-G%s \" \"%s/track%.2d.wav\" 2>&1",rcd_info.c_tracks[count].artist,rcd_info.c_tracks[count].title,rcd_info.title,rcd_info.genre,mdir,count+1);
  if(sel_tracks[count]!=1)continue;
  fptr=popen(buff,"r");
  gtk_clist_set_text((GtkCList*)rip_list,count,2,"Encoding");
  perc=0;

   while(1)
  {
   if(rfgets(fptr,buff)==0)
   break;

   if(perc==1)
   {
    token=strtok(buff,"[");
    if(token!=NULL)
    token=strtok(NULL,"%%");
    if(token!=NULL)
    gtk_progress_set_value(GTK_PROGRESS(progressbar1),atoi(token));
   }
   else
   if(strncmp(buff,"at",2)==0)perc=1;

   while (gtk_events_pending ())
       gtk_main_iteration_do (FALSE);
   if(stop_rip==1)break;
  }

  pclose(fptr);

  gtk_clist_set_text((GtkCList*)rip_list,count,2,"Finished");
  sprintf(buff,"%s/track%.2d.wav",mdir,count+1);
  unlink(buff);
  if(stop_rip==1)break;
 }
 }
else   /* rip to MP3 */
{
 for(count=0;count<rcd_info.tracks;count++) /* outer for loop */
 {

  if(sel_tracks[count]!=1)continue;
if(strlen(rcd_info.c_tracks[count].title)>30)
rcd_info.c_tracks[count].title[30]=0;

if(strlen(rcd_info.title)>30)
rcd_info.title[30]=0;

if(strlen(rcd_info.c_tracks[count].artist)>30)
rcd_info.c_tracks[count].artist[30]=0;
  sprintf(buff,"lame -h --tt \"%s\" --tl \"%s\" --ta \"%s\" \"%s/track%.2d.wav\" \"%s/track%.2d.mp3\" 2>&1",rcd_info.c_tracks[count].title,rcd_info.title,rcd_info.c_tracks[count].artist, mdir,count+1,mdir,count+1);
  fptr=popen(buff,"r");



  gtk_clist_set_text((GtkCList*)rip_list,count,2,"Encoding");
  perc=0;
gtk_progress_set_value(GTK_PROGRESS(progressbar1),0);

mfc=0;
lfc=0;

   while(1)
  {

mfc++;

   /*if(rfgets(fptr,buff)==0)*/
   if((fgets(buff,100,fptr))==NULL)
   break;

   if(mfc>10)
   {
    strcpy(tbuff,buff);
    if((token=strtok(tbuff,"("))!=NULL)
    {
    if((token=strtok(NULL,"\%"))!=NULL)
     lfc=atoi(token);
        if(lfc>0 && lfc <100)
    gtk_progress_set_value(GTK_PROGRESS(progressbar1),lfc);
    }


   }


   while (gtk_events_pending ())
       gtk_main_iteration_do (FALSE);
   if(stop_rip==1)break;
  }

  pclose(fptr);


  gtk_clist_set_text((GtkCList*)rip_list,count,2,"Finished");
  sprintf(buff,"%s/track%.2d.wav",mdir,count+1);
  unlink(buff);

  if(stop_rip==1)break;

 }
}



} /* stop rip */



gtk_widget_destroy(progressbar1);



gtk_entry_set_editable((GtkEntry*)music_direntry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdtitle_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdartist_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)trackname_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)trackartist_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)music_direntry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdgenre_entry,FALSE);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_select_row),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_unselect_row),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (exit_clicked),GTK_SIGNAL_FUNC (on_ripper_window_exit_clicked),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (ripcd_clicked),GTK_SIGNAL_FUNC (on_ripper_window_ripcd_clicked),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (ripsel_clicked),GTK_SIGNAL_FUNC (on_rippper_window_ripsel_clicked),NULL);
gtk_clist_unselect_all((GtkCList*)rip_list);

cd_timer=gtk_timeout_add(250,play_cdauto,NULL);

ignore=0;
}


void
on_ripper_window_title_entry_realize   (GtkWidget       *widget,
                                        gpointer         user_data)
{
cdtitle_entry=widget;
}


void
on_ripper_window_genre_entry_realize   (GtkWidget       *widget,
                                        gpointer         user_data)
{
cdgenre_entry=widget;
}


void
on_ripper_window_year_spin_realize     (GtkWidget       *widget,
                                        gpointer         user_data)
{
cdyear_spin=widget;
}


void
on_ripper_window_year_spin_changed     (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void
on_ripper_window_track_artist_entry_realize
                                        (GtkWidget       *widget,
                                        gpointer         user_data)
{
trackartist_entry=widget;
}



void
on_ripper_window_track_title_entry_realize
                                        (GtkWidget       *widget,
                                        gpointer         user_data)
{
trackname_entry=widget;
}


int ripper_cd()
{
struct cdrom_subchnl status;
int s,num;

if(rip_list==NULL)return 1;

 if(cd_handle<1)
   cd_handle=open_cd(cd_dev);



   status.cdsc_format=CDROM_MSF;
   ioctl(cd_handle,CDROMSUBCHNL,&status);

   s=drive_status_cd(cd_handle);


if(s==1) /* no disc */
{
disk_present=-1;
for(num=0;num<100;num++)
{
free(rcd_info.c_tracks[num].title);
free(rcd_info.c_tracks[num].artist);
rcd_info.c_tracks[num].title=NULL;
rcd_info.c_tracks[num].artist=NULL;
sel_tracks[num]=0;
}

free(rcd_info.title);
free(rcd_info.artist);
free(rcd_info.genre);
rcd_info.title=NULL;
rcd_info.artist=NULL;
rcd_info.genre=NULL;

return 1;
}

else
if(s==2) /* tray open */
{
disk_present=-1;
for(num=0;num<100;num++)
{
free(rcd_info.c_tracks[num].title);
free(rcd_info.c_tracks[num].artist);
rcd_info.c_tracks[num].title=NULL;
rcd_info.c_tracks[num].artist=NULL;
sel_tracks[num]=0;
}

free(rcd_info.title);
free(rcd_info.artist);
free(rcd_info.genre);
rcd_info.title=NULL;
rcd_info.artist=NULL;
rcd_info.genre=NULL;

return 1;
}
else
if(s==3) /* drive not ready */
{
disk_present=-1;
for(num=0;num<100;num++)
{
free(rcd_info.c_tracks[num].title);
free(rcd_info.c_tracks[num].artist);
rcd_info.c_tracks[num].title=NULL;
rcd_info.c_tracks[num].artist=NULL;
sel_tracks[num]=0;
}

free(rcd_info.title);
free(rcd_info.artist);
free(rcd_info.genre);
rcd_info.title=NULL;
rcd_info.artist=NULL;
rcd_info.genre=NULL;

return 1;
}
else
if(s==4 && disk_present!=1)
{

 if(is_audio_cd(cd_handle) && rcd_info.title==NULL)
{
for(num=0;num<100;num++)
sel_tracks[num]=0;
 disk_present=1;
 list_disc();

}

return 1;
}


 return 1;
}



void list_disc()
{
int id;
int matches,num,back;
    cddb_conn_t *conn = NULL;   /* libcddb connection structure */
    cddb_disc_t *disc=NULL;   /* libcddb disc structure */
    struct cdrom_tochdr cdth;
int i;
cddb_track_t *track=NULL;
gchar *dat[3];
char *ebuff;
FILE *fptr;

id=get_disc_id();


gtk_entry_set_text((GtkEntry*)music_direntry,music_dir);

strcpy(l,getenv("HOME"));
strcat(l,"/sonic-rainbow");
mkdir(l,S_IRWXU|S_IRWXG|S_IRWXO);
strcat(l,"/cddb");
mkdir(l,S_IRWXU|S_IRWXG|S_IRWXO);
sprintf(l,"%s/%0x",l,id);

if((fptr=fopen(l,"rb"))!=NULL)
{
fclose(fptr);
if(rfile_read()==1)
return;
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"File %s\nis corrupt Sonic-Rainbow will attempt to re-create\nit from Freedb. If the details are listed as\nUnknown, Sonic-Rainbow was unable to re-create\nthe file from the net and it may be best to\ndelete the file. The file can only be re-created\nif you are connected to the internet when you load\nthe CD with Sonic-Rainbow running",l);
   do_error_message(ebuff);
   free(ebuff);

}


if(!http_lookup)
{
id=get_disc_id();

conn = cddb_new();
if (conn)
{
disc=cddb_disc_new();

cddb_disc_set_length(disc,disc_time);


for (i = 0; i < disc_tracks; i++)
{
    track = cddb_track_new();
    if (track == NULL)
    {
      /* memory error */
      /* need to handle this */
    }
    cddb_track_set_frame_offset(track,frames[i]+SECONDS_TO_FRAMES(2));
    cddb_disc_add_track(disc, track);
}

matches = cddb_query(conn, disc);

if(matches>0)
{
for(i=1;i<matches;i++)
{
if(id==disc->discid)break;
back=cddb_query_next(conn,disc);
}

back=cddb_read(conn,disc);
if(back)
{
if(list_from_net(disc))
{
    cddb_disc_destroy(disc);
    cddb_destroy(conn);
return;
}

}
}


ioctl(cd_handle,CDROMREADTOCHDR,&cdth) ;
rcd_info.tracks=cdth.cdth_trk1;

for(num=0;num<100;num++)
{
free(rcd_info.c_tracks[num].title);
free(rcd_info.c_tracks[num].artist);
rcd_info.c_tracks[num].title=NULL;
rcd_info.c_tracks[num].artist=NULL;
}

free(rcd_info.title);
free(rcd_info.artist);
free(rcd_info.genre);
rcd_info.title=NULL;
rcd_info.artist=NULL;
rcd_info.genre=NULL;

gtk_clist_clear((GtkCList*)rip_list);

    for (num=0;num<rcd_info.tracks;num++)
 {

rcd_info.c_tracks[num].title=(char*)malloc(8);
dat[0]=(char*)malloc(12);
sprintf(dat[0],"%d ",num+1);
strcpy(rcd_info.c_tracks[num].title,"Unknown");
strcat(dat[0],"Unknown");

rcd_info.c_tracks[num].artist=(char*)malloc(8);
dat[1]=(char*)malloc(12);
strcpy(rcd_info.c_tracks[num].artist,"Unknown");
strcpy(dat[1],"Unknown");
dat[2]=NULL;
gtk_clist_append((GtkCList *)rip_list,dat);
free(dat[0]);
free(dat[1]);
free(dat[2]);
 }

rcd_info.artist=(char *)malloc(8);
strcpy(rcd_info.artist,"Unknown");
gtk_entry_set_text((GtkEntry *)cdartist_entry,rcd_info.artist);
rcd_info.title=(char *)malloc(8);
strcpy(rcd_info.title,"Unknown");
gtk_entry_set_text((GtkEntry *)cdtitle_entry,rcd_info.title);
rcd_info.genre=(char *)malloc(8);
strcpy(rcd_info.genre,"Unknown");
gtk_entry_set_text((GtkEntry *)cdgenre_entry,rcd_info.genre);
gtk_spin_button_set_value((GtkSpinButton*)cdyear_spin,1980);
    cddb_disc_destroy(disc);
    cddb_destroy(conn);
return;
    }
}

ioctl(cd_handle,CDROMREADTOCHDR,&cdth) ;
rcd_info.tracks=cdth.cdth_trk1;
for(num=0;num<100;num++)
{
free(rcd_info.c_tracks[num].title);
free(rcd_info.c_tracks[num].artist);
rcd_info.c_tracks[num].title=NULL;
rcd_info.c_tracks[num].artist=NULL;
}

free(rcd_info.title);
free(rcd_info.artist);
free(rcd_info.genre);
rcd_info.title=NULL;
rcd_info.artist=NULL;
rcd_info.genre=NULL;

gtk_clist_clear((GtkCList*)rip_list);

    for (num=0;num<rcd_info.tracks;num++)
 {

rcd_info.c_tracks[num].title=(char*)malloc(8);
dat[0]=(char*)malloc(12);
sprintf(dat[0],"%d ",num+1);
strcpy(rcd_info.c_tracks[num].title,"Unknown");
strcat(dat[0],"Unknown");

rcd_info.c_tracks[num].artist=(char*)malloc(8);
dat[1]=(char*)malloc(12);
strcpy(rcd_info.c_tracks[num].artist,"Unknown");
strcpy(dat[1],"Unknown");
dat[2]=NULL;
gtk_clist_append((GtkCList *)rip_list,dat);
free(dat[0]);
free(dat[1]);
free(dat[2]);
 }

rcd_info.artist=(char *)malloc(8);
strcpy(rcd_info.artist,"Unknown");
gtk_entry_set_text((GtkEntry *)cdartist_entry,rcd_info.artist);

rcd_info.title=(char *)malloc(8);
strcpy(rcd_info.title,"Unknown");
gtk_entry_set_text((GtkEntry *)cdtitle_entry,rcd_info.title);
rcd_info.genre=(char *)malloc(8);
strcpy(rcd_info.genre,"Unknown");
gtk_entry_set_text((GtkEntry *)cdgenre_entry,rcd_info.genre);
gtk_spin_button_set_value((GtkSpinButton*)cdyear_spin,1980);



   cddb_disc_destroy(disc);
    cddb_destroy(conn);

return;
}





#define STR_OR_NULL(s) ((s) ? s : "(null)")

int rfile_read()
{

    int num;
    FILE *fptr;
    struct cdrom_tochdr cdth;
    char tmp[1000];
    gchar *dat[3];


   if(ioctl(cd_handle,CDROMREADTOCHDR,&cdth)<0)
      return -2;


rcd_info.tracks=cdth.cdth_trk1;

for(num=0;num<100;num++)
{
free(rcd_info.c_tracks[num].title);
free(rcd_info.c_tracks[num].artist);
rcd_info.c_tracks[num].title=NULL;
rcd_info.c_tracks[num].artist=NULL;
}

free(rcd_info.title);
free(rcd_info.artist);
free(rcd_info.genre);
rcd_info.title=NULL;
rcd_info.artist=NULL;
rcd_info.genre=NULL;



gtk_clist_clear((GtkCList*)rip_list);

fptr=fopen(l,"rb");

    /* 1. The artist name, disc title and extended data. */
if((fgets(tmp,500,fptr))==NULL){fclose(fptr);return -1;}
tmp[strlen(tmp)-1]=0;
rcd_info.artist=(char *)malloc(strlen(tmp)+1);
strcpy(rcd_info.artist,tmp);
gtk_entry_set_text((GtkEntry *)cdartist_entry,rcd_info.artist);

if((fgets(tmp,500,fptr))==NULL){fclose(fptr); free(rcd_info.artist); rcd_info.artist=NULL;return -1;}
tmp[strlen(tmp)-1]=0;
rcd_info.title=(char *)malloc(strlen(tmp)+1);
strcpy(rcd_info.title,tmp);
gtk_entry_set_text((GtkEntry *)cdtitle_entry,rcd_info.title);

    /* 2. The music genre.  This field is similar to the category*/
if((fgets(tmp,500,fptr))==NULL){fclose(fptr); free(rcd_info.artist); free(rcd_info.title);rcd_info.artist=NULL;
rcd_info.title=NULL; return -1;}
tmp[strlen(tmp)-1]=0;
rcd_info.genre=(char *)malloc(strlen(tmp)+1);
strcpy(rcd_info.genre,tmp);
gtk_entry_set_text((GtkEntry *)cdgenre_entry,rcd_info.genre);


    /* 3. The disc year. */
if((fgets(tmp,500,fptr))==NULL){fclose(fptr); free(rcd_info.genre);free(rcd_info.artist); free(rcd_info.title);
rcd_info.artist=NULL;rcd_info.title=NULL;rcd_info.genre=NULL; return -1;}
tmp[strlen(tmp)-1]=0;
gtk_spin_button_set_value((GtkSpinButton*)cdyear_spin,atoi(tmp));

    /* 4. The disc length and the number of tracks.  The length field
       is given in seconds. */
 /*   length = cddb_disc_get_length(disc);*/
if((fgets(tmp,500,fptr))==NULL){fclose(fptr); free(rcd_info.genre);free(rcd_info.artist); free(rcd_info.title);rcd_info.artist=NULL;rcd_info.title=NULL;rcd_info.genre=NULL;return -1;}
if((fgets(tmp,500,fptr))==NULL){fclose(fptr); free(rcd_info.genre);free(rcd_info.artist); free(rcd_info.title);rcd_info.artist=NULL;rcd_info.title=NULL;rcd_info.genre=NULL;return -1;}
/*
    fprintf(fptr,"%d:%02d\n", (length / 60), (length % 60));
    fprintf(fptr,"%d\n", cddb_disc_get_track_count(disc));
*/
    /* 5. The tracks.  Track iteration can either be done by counting
       from 0 to (track_count - 1) and using the cddb_disc_get_track
       function.  Or by using the built-in iterator functions
       cddb_disc_get_track_first and cddb_disc_get_track_next.  We'll
       use the latter approach in this example. */

    for (num=0;num<rcd_info.tracks;num++)
 {

        /* 5.a. The track number on the disc.  This track number
           starts counting at 1.  So this is not the same number as
           the one used in cddb_disc_get_track. */

          if((fgets(tmp,500,fptr))==NULL)
	  {
	   fclose(fptr); free(rcd_info.genre);free(rcd_info.artist); free(rcd_info.title);
 rcd_info.artist=NULL;rcd_info.title=NULL;rcd_info.genre=NULL;
           for(num=0;num<100;num++)
            {
             free(rcd_info.c_tracks[num].title);
             free(rcd_info.c_tracks[num].artist);
             rcd_info.c_tracks[num].title=NULL;
            rcd_info.c_tracks[num].artist=NULL;
            }
            return -1;
          }

        /* 5.b. The track artist name and title. */

if((fgets(tmp,500,fptr))==NULL)
	  {
	   fclose(fptr); free(rcd_info.genre);free(rcd_info.artist); free(rcd_info.title);
 rcd_info.artist=NULL;rcd_info.title=NULL;rcd_info.genre=NULL;
           for(num=0;num<100;num++)
            {
             free(rcd_info.c_tracks[num].title);
             free(rcd_info.c_tracks[num].artist);
             rcd_info.c_tracks[num].title=NULL;
            rcd_info.c_tracks[num].artist=NULL;
            }
            return -1;
          }
tmp[strlen(tmp)-1]=0;
rcd_info.c_tracks[num].title=(char*)malloc(strlen(tmp)+1);
dat[0]=(char*)malloc(strlen(tmp)+4);
sprintf(dat[0],"%d ",num+1);
strcpy(rcd_info.c_tracks[num].title,tmp);
strcat(dat[0],tmp);

if((fgets(tmp,500,fptr))==NULL)
	  {
	   fclose(fptr); free(rcd_info.genre);free(rcd_info.artist); free(rcd_info.title);
 rcd_info.artist=NULL;rcd_info.title=NULL;rcd_info.genre=NULL;
           for(num=0;num<100;num++)
            {
             free(rcd_info.c_tracks[num].title);
             free(rcd_info.c_tracks[num].artist);
             rcd_info.c_tracks[num].title=NULL;
            rcd_info.c_tracks[num].artist=NULL;
            }
            return -1;
          }
tmp[strlen(tmp)-1]=0;
rcd_info.c_tracks[num].artist=(char*)malloc(strlen(tmp)+1);
dat[1]=(char*)malloc(strlen(tmp)+1);
strcpy(rcd_info.c_tracks[num].artist,tmp);
strcpy(dat[1],tmp);
dat[2]=NULL;
        /* 5.c. The track length. */
if((fgets(tmp,500,fptr))==NULL)
	  {
	   fclose(fptr); free(rcd_info.genre);free(rcd_info.artist); free(rcd_info.title);
 rcd_info.artist=NULL;rcd_info.title=NULL;rcd_info.genre=NULL;
           for(num=0;num<100;num++)
            {
             free(rcd_info.c_tracks[num].title);
             free(rcd_info.c_tracks[num].artist);
             rcd_info.c_tracks[num].title=NULL;
            rcd_info.c_tracks[num].artist=NULL;
            }
            return -1;
          }
gtk_clist_append((GtkCList *)rip_list,dat);
free(dat[0]);
free(dat[1]);
free(dat[2]);

    }
fclose(fptr);
return 1;
}



int list_from_net(cddb_disc_t *disc)
{
    cddb_track_t *track = NULL; /* libcddb track structure */
    int length,num=0;
    FILE *fptr;
char *ebuff;
struct cdrom_tochdr cdth;
gchar *dat[3];
int ret;


   if(ioctl(cd_handle,CDROMREADTOCHDR,&cdth)<0)
   {
     ebuff=(char *)malloc(5000);
sprintf(ebuff,"Sonic-Rainbow cannot read from CDROM Drive");
   do_error_message(ebuff);
   free(ebuff);
   ret=-1;
      return -1;
   }


gtk_clist_clear((GtkCList*)rip_list);

for(num=0;num<100;num++)
{
free(rcd_info.c_tracks[num].title);
free(rcd_info.c_tracks[num].artist);
rcd_info.c_tracks[num].title=NULL;
rcd_info.c_tracks[num].artist=NULL;
}

free(rcd_info.title);
free(rcd_info.artist);
free(rcd_info.genre);
rcd_info.title=NULL;
rcd_info.artist=NULL;
rcd_info.genre=NULL;
rcd_info.tracks=0;


rcd_info.tracks=cdth.cdth_trk1;

fptr=fopen(l,"wb");
{
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"Sonic-Rainbow cannot create File\n%s\nThis may be a permissions based problem",l);
   do_error_message(ebuff);
   free(ebuff);
   ret=-1;
}
    /* 1. The artist name, disc title and extended data. */
rcd_info.artist=(char *)malloc(strlen(STR_OR_NULL(cddb_disc_get_artist(disc)))+1);
strcpy(rcd_info.artist,STR_OR_NULL(cddb_disc_get_artist(disc)));
gtk_entry_set_text((GtkEntry *)cdartist_entry,rcd_info.artist);

rcd_info.title=(char*)malloc( strlen(cddb_disc_get_title(disc))+1);
strcpy(rcd_info.title,cddb_disc_get_title(disc));
gtk_entry_set_text((GtkEntry *)cdtitle_entry,rcd_info.title);

if(fptr)
{
    fprintf(fptr,"%s\n", STR_OR_NULL(cddb_disc_get_artist(disc)));
    fprintf(fptr,"%s\n", STR_OR_NULL(cddb_disc_get_title(disc)));
}
    /* 2. The music genre.  This field is similar to the category
       field initialized above.  It can be the same but it does not
       have to be.  The category can only be come from a set of CDDB
       predefined categories.  The genre can be any string. */
rcd_info.genre=(char*)malloc(strlen(STR_OR_NULL(cddb_disc_get_genre(disc)))+1);
strcpy(rcd_info.genre,STR_OR_NULL(cddb_disc_get_genre(disc)));
gtk_entry_set_text((GtkEntry *)cdgenre_entry,rcd_info.genre);

if(fptr)
    fprintf(fptr,"%s\n", STR_OR_NULL(cddb_disc_get_genre(disc)));

    /* 3. The disc year. */
if(fptr)
    fprintf(fptr,"%d\n", cddb_disc_get_year(disc));
gtk_spin_button_set_value((GtkSpinButton*)cdyear_spin,cddb_disc_get_year(disc));
    /* 4. The disc length and the number of tracks.  The length field
       is given in seconds. */
    length = cddb_disc_get_length(disc);
if(fptr)
{
    fprintf(fptr,"%d:%02d\n", (length / 60), (length % 60));
    fprintf(fptr,"%d\n", cddb_disc_get_track_count(disc));
}
    /* 5. The tracks.  Track iteration can either be done by counting
       from 0 to (track_count - 1) and using the cddb_disc_get_track
       function.  Or by using the built-in iterator functions
       cddb_disc_get_track_first and cddb_disc_get_track_next.  We'll
       use the latter approach in this example. */


num=0;
    for (track = cddb_disc_get_track_first(disc);
         track != NULL;
         track = cddb_disc_get_track_next(disc))
 {

        /* 5.a. The track number on the disc.  This track number
           starts counting at 1.  So this is not the same number as
           the one used in cddb_disc_get_track. */
if(fptr)
{
        fprintf(fptr,"%d\n", cddb_track_get_number(track));
        fprintf(fptr,"%s\n%s\n", cddb_track_get_title(track),
               cddb_track_get_artist(track));
}

rcd_info.c_tracks[cddb_track_get_number(track)-1].title=(char*)malloc(strlen(cddb_track_get_title(track))+1);
strcpy(rcd_info.c_tracks[cddb_track_get_number(track)-1].title,cddb_track_get_title(track));
dat[0]=(char*)malloc(strlen(cddb_track_get_title(track))+4);
num++;
sprintf(dat[0],"%d ",num);
strcat(dat[0],cddb_track_get_title(track));

rcd_info.c_tracks[cddb_track_get_number(track)-1].artist=(char*)malloc(strlen(cddb_track_get_artist(track))+1);
dat[1]=(char*)malloc(strlen(cddb_track_get_artist(track))+1);
strcpy(dat[1],cddb_track_get_artist(track));
strcpy(rcd_info.c_tracks[cddb_track_get_number(track)-1].artist,cddb_track_get_artist(track));
dat[2]=NULL;
gtk_clist_append((GtkCList *)rip_list,dat);
free(dat[0]);
free(dat[1]);
free(dat[2]);
        /* 5.c. The track length. */
        length = cddb_track_get_length(track);

        if (length != -1) {
	if(fptr)
            fprintf(fptr,"%d:%02d\n", (length / 60), (length % 60));
        } else {
	if(fptr)
            fprintf(fptr,"0:0");
        }

    }
fclose(fptr);
return 1;
}

void
on_entry1_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
music_direntry=widget;
}




void
on_ripper_window_oggfile_realize       (GtkWidget       *widget,
                                        gpointer         user_data)
{
if(!canogg||!cancdda)
{
gtk_widget_set_sensitive (widget, FALSE);
gtk_toggle_button_set_mode((GtkToggleButton*)widget,0);
}
else
gtk_toggle_button_set_active((GtkToggleButton*)widget,1);

ogg_form=widget;
}


void
on_setup_window_mp3_realize            (GtkWidget       *widget,
                                        gpointer         user_data)
{
if(!canmp3||!cancdda)
{
gtk_widget_set_sensitive (widget, FALSE);
gtk_toggle_button_set_mode((GtkToggleButton*)widget,0);
}
else
gtk_toggle_button_set_active((GtkToggleButton*)widget,1);
}


void on_edvd_clicked         (GtkButton       *button, gpointer         user_data)
{
int a;
a=open("/dev/dvd",O_RDONLY);
ioctl(a,CDROMEJECT);
close(a);
}

void
on_ripper_window_wav_realize           (GtkWidget       *widget,
                                        gpointer         user_data)
{
if(!cancdda)
{
gtk_widget_set_sensitive (widget, FALSE);
}
if(!canmp3 && !canogg)
gtk_toggle_button_set_active((GtkToggleButton*)widget,1);
wav_form=widget;
}
