/*
Sonic Rainbow written by Gary Baker South Australia.
Copyright (C) 2003 Gary Baker

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/* gary */

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <string.h>
#include <malloc.h>
#include <unistd.h>
#include <linux/soundcard.h>
#include <ao/ao.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <mad.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/mman.h>

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "cd.h"
#include <sys/types.h>
#include <dirent.h>
#include <vorbis/vorbisfile.h>
#include <vorbis/codec.h>
#include <mad.h>
#include <id3tag.h>
#include <audiofile.h>


extern GtkWidget *main_window_oggscrolled;
extern GtkWidget *main_window_oggclist;
extern int global_exit;
GtkWidget *main_window_ogg_entry;

int load_play();
int ismp3(char *);
void play_wav();

extern int cd_handle,completed;
extern int disk_present;
extern int sel_tracks[100];
extern guint cd_timer;
extern GtkWidget *rlist_item;
extern GtkWidget *rip_list;
extern char *music_dir;
extern int isok,plist_autoplay;
extern char default_playlist_file[1000];
extern char default_playlist_dir[1000];
extern int play_error;
extern int http_lookup;

GtkWidget *oggf,*playlist_direntry,*gw,*create_plist,*fentry,*dentry,*lp,*cp,*cpa,*bpa;
GtkWidget *mp,*mpa,*mpb,*mod_playlist_direntry;
GtkWidget *dw;

int dowhat=0;
int play_num=0;
int ogglist_first=0;
int oggscrolled_first=0;
char oggfiledir[1000];
int ogg_files=0;
int ogg_file_count();
int isogg(char *);
void free_ogg_files();
int play_ogg(int ofp);
void play_single_mp3(char t[]);

int psel=-1;
int ismod=0;
int pauseres=0;
int inplayogg=0;

struct oggdir
{
char *file_path;
char *fname;
char *title;
char *artist;
} **ogg_dir;


ao_device *device=NULL;
ao_sample_format format;
int default_driver;
int play_mpeg(char *mp3);


static enum mad_flow input(void *data,struct mad_stream *stream);
static inline signed int scale(mad_fixed_t sample);
static enum mad_flow error(void *data,struct mad_stream *stream,struct mad_frame *frame);
static int decode(unsigned char const *start, unsigned long length);
static enum mad_flow output(void *data,struct mad_header const *header,struct mad_pcm *pcm);
void do_error_message(char *text);
int iswav(char *);
int isplaylist(char *fn);
void play_single_ogg(char *);
void play_single_wav(char t[]);
void
on_main_window_drag_data_received      (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);


void
on_main_window_drag_data_received      (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data)
{
FILE *mfptr;
char *mtoken=NULL;

if((mfptr=fopen("/tmp/sr.tmp","wb"))==NULL)exit(0);
fprintf(mfptr,"Sonic-Rainbow Playlist\n");
while(1)
{
if(mtoken==NULL)
mtoken=strtok(data->data,"\n");
else
mtoken=strtok(NULL,"\n");
if(mtoken==NULL)break;
if(strncasecmp(mtoken,"file:/",6)==0)
fprintf(mfptr,"%s\n",mtoken+5);
else
fprintf(mfptr,"%s\n",mtoken);
}
fclose(mfptr);

dowhat=-2;
if(inplayogg)return;
load_play("/tmp/sr.tmp");
/*
on_main_window_stopogg_clicked(NULL,NULL);
*/
on_main_window_playogg_clicked(NULL,NULL);
return;
}



void play_single_wav(char t[])
{
int n=0;
char  *dat[2];

    ogg_files=1;
    n=0;
    ogg_dir=(struct oggdir **)calloc(ogg_files,sizeof(struct oggdir *));

    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;

    ogg_dir[n]->title=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->title,"Unknown");
    ogg_dir[n]->artist=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->artist,"Unknown");


for(n=0;n<ogg_files;n++)
{
    dat[0]=ogg_dir[n]->title;
    dat[1]=ogg_dir[n]->artist;
    gtk_clist_append((GtkCList *)main_window_oggclist,dat);
}

gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[0]->title);

}




void play_single_ogg(char t[])
{
int n=0;
FILE *fptr;
OggVorbis_File vf;
char *token, *dat[2];
int i;


   if((fptr=fopen(t,"rb"))!=NULL)
   {

   if(ov_open(fptr, &vf, NULL, 0)>=0)
   {
    ogg_files=1;
    n=0;
    ogg_dir=(struct oggdir **)calloc(ogg_files,sizeof(struct oggdir *));

    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;

       for(i=0;i<vf.vc->comments;i++)
        {
             if(strncasecmp("title=",vf.vc->user_comments[i],6)==0)
               {

                 token=strtok(vf.vc->user_comments[i],"=");
                token=strtok(NULL,"");
                ogg_dir[n]->title=(char *)malloc(strlen(token)+1);
               strcpy(ogg_dir[n]->title,token);
              dat[0]=ogg_dir[n]->title;
               }
               else
              if(strncasecmp("artist=",vf.vc->user_comments[i],6)==0)
              {
               token=strtok(vf.vc->user_comments[i],"=");
               token=strtok(NULL,"");
               ogg_dir[n]->artist=(char *)malloc(strlen(token)+1);
               strcpy(ogg_dir[n]->artist,token);
               dat[1]=ogg_dir[n]->artist;
              }

         }


 n++;
 ov_clear(&vf);
  }

for(n=0;n<ogg_files;n++)
{
    dat[0]=ogg_dir[n]->title;
    dat[1]=ogg_dir[n]->artist;
    gtk_clist_append((GtkCList *)main_window_oggclist,dat);
}

gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[0]->title);

}




}






void play_single_mp3(char t[])
{
int n=0;
char *dat[2];
struct id3_file *id3_f=NULL;
struct id3_tag *id3_t=NULL;
struct id3_frame *fr=NULL;
id3_latin1_t *b;



    ogg_files=1;
    n=0;
    ogg_dir=(struct oggdir **)calloc(ogg_files,sizeof(struct oggdir *));
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;


    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);




    id3_f=id3_file_open(t,ID3_FILE_MODE_READONLY);

    if(id3_f!=NULL)
    {
     id3_t= id3_file_tag(id3_f);
      if(id3_t!=NULL)
      {

          fr=id3_tag_findframe(id3_t,"TIT2",0);
	  if(fr!=NULL)
	  {
	  if(fr->fields[1].type==4 || fr->fields[1].type==5 ||fr->fields[1].type==6 )
	  {
	  b=id3_ucs4_latin1duplicate(fr->fields[1].stringlist.strings[0]);
	  ogg_dir[n]->title=(char *)malloc(strlen(b)+1);
          strcpy(ogg_dir[n]->title,b);
	  free(b);
	  }
	  else
	  {
           ogg_dir[n]->title=(char *)malloc(strlen((char *)fr->fields[1].stringlist.strings[0])+1);
           strcpy(ogg_dir[n]->title,(char *)fr->fields[1].stringlist.strings[0]);
	   }
	  }


          fr=id3_tag_findframe(id3_t,"TPE1",0);
          if(fr!=NULL)
	  {
	   if(fr->fields[1].type==4 || fr->fields[1].type==5 ||fr->fields[1].type==6 )
	   {
	   b=id3_ucs4_latin1duplicate(fr->fields[1].stringlist.strings[0]);
	   ogg_dir[n]->artist=(char *)malloc(strlen(b)+1);
           strcpy(ogg_dir[n]->artist,b);
	   free(b);
	   }
	   else
	   {
            ogg_dir[n]->artist=(char *)malloc(strlen((char *)fr->fields[1].stringlist.strings[0])+1);
            strcpy(ogg_dir[n]->artist,(char *)fr->fields[1].stringlist.strings[0]);
	   }
	  }

      }  /* id3_t !=NULL */
    } /* id3 !=NULL */


if(ogg_dir[n]->title==NULL)
{
    ogg_dir[n]->title=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->title,"Unknown");
}


if(ogg_dir[n]->artist==NULL)
{
    ogg_dir[n]->artist=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->artist,"Unknown");
}

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;
    n++;


for(n=0;n<ogg_files;n++)
{
    dat[0]=ogg_dir[n]->title;
    dat[1]=ogg_dir[n]->artist;
    gtk_clist_append((GtkCList *)main_window_oggclist,dat);
}


gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[0]->title);

}







void on_main_window_playogg_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
static int num=-1;

inplayogg=1;

dowhat=0;

if(num==-1)
{
for(num=play_num;num<ogg_files;num++)
{
dowhat=0;
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[num]->title);
if(ismp3(ogg_dir[num]->file_path))
{
play_mpeg(ogg_dir[num]->file_path);
}
else
if(iswav(ogg_dir[num]->file_path))
{
play_wav(ogg_dir[num]->file_path);
}
else
play_ogg(num);
if(global_exit)break;
if(dowhat==-2){load_play("/tmp/sr.tmp");num=play_num-1;continue;}
if(dowhat==-1)break;   /* stop */
if(dowhat==1)continue;
if(dowhat==2){num=play_num-1;continue;}
if(dowhat==3){num=play_num;continue;}
}


num=-1;
}

inplayogg=0;

dowhat=0;
}






void
on_main_window_playogg_realize         (GtkWidget       *widget,
                                        gpointer         user_data)
{
dowhat=0;
}


void
on_main_window_stopogg_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
dowhat=-1;
pauseres=0;
}


void
on_main_window_stopogg_realize         (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_main_window_prevogg_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
dowhat=2;
if(play_num>0)play_num--;
if(ogg_dir!=NULL)
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[play_num]->title);
pauseres=0;
}


void
on_main_window_prevogg_realize         (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_main_window_nextogg_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
dowhat=1;
if(play_num<ogg_files-1)play_num++;
if(ogg_dir!=NULL)
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[play_num]->title);
pauseres=0;
}


void
on_main_window_nextogg_realize         (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_main_window_pauseogg_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
pauseres=1;
}


void
on_main_window_pauseogg_realize        (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_main_window_resogg_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
pauseres=0;
}


void
on_main_window_resogg_realize          (GtkWidget       *widget,
                                        gpointer         user_data)
{
;
}


void
on_main_window_browaeogg_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
oggf=create_ogg_browse();
gtk_file_selection_set_filename ((GtkFileSelection *)oggf,music_dir);
gtk_widget_show (oggf);

}


void
on_main_window_browaeogg_realize       (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_main_window_listogg_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{

if(ogglist_first==0)
{
gtk_widget_show(main_window_oggscrolled);
gtk_widget_show(main_window_oggclist);
ogglist_first=1;
}
else
{
gtk_widget_hide(main_window_oggclist);
gtk_widget_hide(main_window_oggscrolled);
ogglist_first=0;
}

}





void
on_main_window_listogg_realize         (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_main_window_oggclist_select_row     (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
gtk_widget_hide(main_window_oggscrolled);
gtk_widget_hide(main_window_oggclist);
ogglist_first=0;
oggscrolled_first=1;
play_num=row;
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[play_num]->title);

if(inplayogg==0)
on_main_window_playogg_clicked(NULL,NULL);
else
{
play_num--;
dowhat=3;
}
}


void
on_main_window_oggclist_realize        (GtkWidget       *widget,
                                        gpointer         user_data)
{

}

void
on_main_window_oggclist_map            (GtkWidget       *widget,
                                        gpointer         user_data)
{

}

void
on_scrolledwindow2_map                 (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_scrolledwindow2_realize             (GtkWidget       *widget,
                                        gpointer         user_data)
{

}





void
on_ogg_browse_ok_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
DIR *d;
int i,n;
struct dirent *dent=NULL;
char *dat[2],*token;
char t[1000];
FILE *fptr;
OggVorbis_File vf;
struct oggdir *ta;
struct id3_file *id3_f=NULL;
struct id3_tag *id3_t=NULL;
struct id3_frame *fr=NULL;
id3_latin1_t *b;



strcpy(oggfiledir,gtk_file_selection_get_filename (GTK_FILE_SELECTION (oggf)));
/*
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,oggfiledir);
*/
gtk_clist_clear((GtkCList*)main_window_oggclist);

if(ogg_files)
free_ogg_files();



 if(oggfiledir[strlen(oggfiledir)-1]!='/')
{
ogg_files=1;
n=0;
ogg_dir=(struct oggdir **)calloc(ogg_files,sizeof(struct oggdir *));
strcpy(t,oggfiledir);

if(iswav(t))
{
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;
    ogg_dir[n]->title=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->title,"Unknown");
    ogg_dir[n]->artist=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->artist,"Unknown");
n++;
}
else
   if((fptr=fopen(t,"rb"))!=NULL)
   {
   if(ov_open(fptr, &vf, NULL, 0)>=0)
   {
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;
       for(i=0;i<vf.vc->comments;i++)
        {
             if(strncasecmp("title=",vf.vc->user_comments[i],6)==0)
               {

                 token=strtok(vf.vc->user_comments[i],"=");
                token=strtok(NULL,"");
                ogg_dir[n]->title=(char *)malloc(strlen(token)+1);
               strcpy(ogg_dir[n]->title,token);
              dat[0]=ogg_dir[n]->title;
        }
        else
          if(strncasecmp("artist=",vf.vc->user_comments[i],6)==0)
       {

        token=strtok(vf.vc->user_comments[i],"=");
        token=strtok(NULL,"");
        ogg_dir[n]->artist=(char *)malloc(strlen(token)+1);
        strcpy(ogg_dir[n]->artist,token);
         dat[1]=ogg_dir[n]->artist;
        }

       }


 n++;
 ov_clear(&vf);
 fclose(fptr);
  }
  else /*maybe mp3 */
  {
    fclose(fptr);
    if(ismp3(t))
    {
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;



    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);

    id3_f=id3_file_open(t,ID3_FILE_MODE_READONLY);
    if(id3_f!=NULL)
    {
     id3_t= id3_file_tag(id3_f);
      if(id3_t!=NULL)
      {
          fr=id3_tag_findframe(id3_t,"TIT2",0);
	  if(fr!=NULL)
	  {
	  if(fr->fields[1].type==4 || fr->fields[1].type==5 ||fr->fields[1].type==6 )
	  {
	  b=id3_ucs4_latin1duplicate(fr->fields[1].stringlist.strings[0]);
	  ogg_dir[n]->title=(char *)malloc(strlen(b)+1);
          strcpy(ogg_dir[n]->title,b);
	  free(b);
	  }
	  else
	  {
           ogg_dir[n]->title=(char *)malloc(strlen((char *)fr->fields[1].stringlist.strings[0])+1);
           strcpy(ogg_dir[n]->title,(char *)fr->fields[1].stringlist.strings[0]);
	   }
	  }


          fr=id3_tag_findframe(id3_t,"TPE1",0);
          if(fr!=NULL)
	  {
	   if(fr->fields[1].type==4 || fr->fields[1].type==5 ||fr->fields[1].type==6 )
	   {
	   b=id3_ucs4_latin1duplicate(fr->fields[1].stringlist.strings[0]);
	   ogg_dir[n]->artist=(char *)malloc(strlen(b)+1);
           strcpy(ogg_dir[n]->artist,b);
	   free(b);
	   }
	   else
	   {
            ogg_dir[n]->artist=(char *)malloc(strlen((char *)fr->fields[1].stringlist.strings[0])+1);
            strcpy(ogg_dir[n]->artist,(char *)fr->fields[1].stringlist.strings[0]);
	   }
	  }

      }  /* id3_t !=NULL */
    } /* id3 !=NULL */

if(ogg_dir[n]->title==NULL)
{
    ogg_dir[n]->title=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->title,"Unknown");
}

if(ogg_dir[n]->artist==NULL)
{
    ogg_dir[n]->artist=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->artist,"Unknown");
}

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;
    n++;
    }  /* is mp3  file */
else
{
ogg_files=0;
gtk_widget_destroy(oggf);
return;
}
  } /* else */
 }  /* if it a file not a dir */


for(n=0;n<ogg_files;n++)
{

    dat[0]=ogg_dir[n]->title;
    dat[1]=ogg_dir[n]->artist;
    dat[2]=NULL;
    gtk_clist_append((GtkCList *)main_window_oggclist,dat);
}

if(n==0)
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,"");
else
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[0]->title);
play_num=0;
gtk_widget_destroy(oggf);

 return;
}




ogg_files=ogg_file_count();

if(ogg_files==0)
{
/*
is_ogg_file();
*/
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,"");
play_num=0;
gtk_widget_destroy(oggf);
return;
}


if(ogg_files!=0)
ogg_dir=(struct oggdir **)calloc(ogg_files,sizeof(struct oggdir *));
else
ogg_dir=NULL;

if(strlen(oggfiledir)!=0)
{

 if(oggfiledir[strlen(oggfiledir)-1]=='/')
 {
  d=opendir(oggfiledir);
  if(d==NULL)printf("\nfailed to opendir\n");
  n=0;
  while(1)
  {
   dent=readdir(d);
  if(dent==NULL)break;
  if(dent->d_name[0]!='.')
  {

   strcpy(t,oggfiledir);
   strcat(t,dent->d_name);

if(iswav(t))
{
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;
    ogg_dir[n]->title=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->title,"Unknown");
    ogg_dir[n]->artist=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->artist,"Unknown");
n++;
}
else
   if((fptr=fopen(t,"rb"))!=NULL)
   {
   if(ov_open(fptr, &vf, NULL, 0)>=0)
   {

    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(dent->d_name)+1);
    strcpy(ogg_dir[n]->fname,dent->d_name);

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;

       for(i=0;i<vf.vc->comments;i++)
        {

             if(strncasecmp("title=",vf.vc->user_comments[i],6)==0)
               {

                 token=strtok(vf.vc->user_comments[i],"=");
                token=strtok(NULL,"");
                ogg_dir[n]->title=(char *)malloc(strlen(token)+1);
               strcpy(ogg_dir[n]->title,token);
              dat[0]=ogg_dir[n]->title;
               }
               else
              if(strncasecmp("artist=",vf.vc->user_comments[i],6)==0)
              {
               token=strtok(vf.vc->user_comments[i],"=");
               token=strtok(NULL,"");
               ogg_dir[n]->artist=(char *)malloc(strlen(token)+1);
               strcpy(ogg_dir[n]->artist,token);
               dat[1]=ogg_dir[n]->artist;
              }

         }


 n++;
 ov_clear(&vf);
  }
  else /* maybe mp3 */
  {
    fclose(fptr);
       if(ismp3(t))
    {
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);
    id3_f=id3_file_open(t,ID3_FILE_MODE_READONLY);
    if(id3_f!=NULL)
    {
     id3_t= id3_file_tag(id3_f);
      if(id3_t!=NULL)
      {
          fr=id3_tag_findframe(id3_t,"TIT2",0);
	  if(fr!=NULL)
	  {
	  if(fr->fields[1].type==4 || fr->fields[1].type==5 ||fr->fields[1].type==6 )
	  {
	  b=id3_ucs4_latin1duplicate(fr->fields[1].stringlist.strings[0]);
	  ogg_dir[n]->title=(char *)malloc(strlen(b)+1);
          strcpy(ogg_dir[n]->title,b);
	  free(b);
	  }
	  else
	  {
           ogg_dir[n]->title=(char *)malloc(strlen((char *)fr->fields[1].stringlist.strings[0])+1);
           strcpy(ogg_dir[n]->title,(char *)fr->fields[1].stringlist.strings[0]);
	   }
	  }


          fr=id3_tag_findframe(id3_t,"TPE1",0);
          if(fr!=NULL)
	  {
	   if(fr->fields[1].type==4 || fr->fields[1].type==5 ||fr->fields[1].type==6 )
	   {
	   b=id3_ucs4_latin1duplicate(fr->fields[1].stringlist.strings[0]);
	   ogg_dir[n]->artist=(char *)malloc(strlen(b)+1);
           strcpy(ogg_dir[n]->artist,b);
	   free(b);
	   }
	   else
	   {
            ogg_dir[n]->artist=(char *)malloc(strlen((char *)fr->fields[1].stringlist.strings[0])+1);
            strcpy(ogg_dir[n]->artist,(char *)fr->fields[1].stringlist.strings[0]);
	   }
	  }

      }  /* id3_t !=NULL */
    } /* id3 !=NULL */

if(ogg_dir[n]->title==NULL)
{
    ogg_dir[n]->title=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->title,"Unknown");
}
if(ogg_dir[n]->artist==NULL)
{
    ogg_dir[n]->artist=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->artist,"Unknown");
}

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;
    n++;
    }
  }



 }



}
}


  while(1)
  {
   dent=readdir(d);
  if(dent==NULL)break;
  if(dent->d_name[0]!='.')
  {

   strcpy(t,oggfiledir);
   strcat(t,dent->d_name);

if(iswav(t))
{
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;
    ogg_dir[n]->title=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->title,"Unknown");
    ogg_dir[n]->artist=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->artist,"Unknown");
}
else
   if((fptr=fopen(t,"rb"))!=NULL)
   {
   if(ov_open(fptr, &vf, NULL, 0)>=0)
   {
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(dent->d_name)+1);
    strcpy(ogg_dir[n]->fname,dent->d_name);

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;
       for(i=0;i<vf.vc->comments;i++)
        {
             if(strncasecmp("title=",vf.vc->user_comments[i],6)==0)
               {

                 token=strtok(vf.vc->user_comments[i],"=");
                token=strtok(NULL,"");
                ogg_dir[n]->title=(char *)malloc(strlen(token)+1);
               strcpy(ogg_dir[n]->title,token);
              dat[0]=ogg_dir[n]->title;
               }
               else
              if(strncasecmp("artist=",vf.vc->user_comments[i],6)==0)
              {
               token=strtok(vf.vc->user_comments[i],"=");
               token=strtok(NULL,"");
               ogg_dir[n]->artist=(char *)malloc(strlen(token)+1);
               strcpy(ogg_dir[n]->artist,token);
               dat[1]=ogg_dir[n]->artist;
              }

         }


 n++;
 ov_clear(&vf);
  }
  else  /* else maybe mp3 */
  {
   fclose(fptr);
       if(ismp3(t))
    {
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);
   id3_f=id3_file_open(t,ID3_FILE_MODE_READONLY);
    if(id3_f!=NULL)
    {
     id3_t= id3_file_tag(id3_f);
      if(id3_t!=NULL)
      {
          fr=id3_tag_findframe(id3_t,"TIT2",0);
	  if(fr!=NULL)
	  {
	  if(fr->fields[1].type==4 || fr->fields[1].type==5 ||fr->fields[1].type==6 )
	  {
	  b=id3_ucs4_latin1duplicate(fr->fields[1].stringlist.strings[0]);
	  ogg_dir[n]->title=(char *)malloc(strlen(b)+1);
          strcpy(ogg_dir[n]->title,b);
	  free(b);
	  }
	  else
	  {
           ogg_dir[n]->title=(char *)malloc(strlen((char *)fr->fields[1].stringlist.strings[0])+1);
           strcpy(ogg_dir[n]->title,(char *)fr->fields[1].stringlist.strings[0]);
	   }
	  }


          fr=id3_tag_findframe(id3_t,"TPE1",0);
          if(fr!=NULL)
	  {
	   if(fr->fields[1].type==4 || fr->fields[1].type==5 ||fr->fields[1].type==6 )
	   {
	   b=id3_ucs4_latin1duplicate(fr->fields[1].stringlist.strings[0]);
	   ogg_dir[n]->artist=(char *)malloc(strlen(b)+1);
           strcpy(ogg_dir[n]->artist,b);
	   free(b);
	   }
	   else
	   {
            ogg_dir[n]->artist=(char *)malloc(strlen((char *)fr->fields[1].stringlist.strings[0])+1);
            strcpy(ogg_dir[n]->artist,(char *)fr->fields[1].stringlist.strings[0]);
	   }
	  }

      }  /* id3_t !=NULL */
    } /* id3 !=NULL */

if(ogg_dir[n]->title==NULL)
{
    ogg_dir[n]->title=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->title,"Unknown");
}

if(ogg_dir[n]->title==NULL)
{
    ogg_dir[n]->artist=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->artist,"Unknown");
}

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;
    n++;
    }
  }


 }



}
}


closedir(d);
}


}



if(ogg_files>0)
{
for(n=0;n<ogg_files-1;n++)
for(i=n;i<ogg_files-1;i++)
{
if(strcmp(ogg_dir[n]->file_path,ogg_dir[i+1]->file_path)>0)
{
ta=ogg_dir[i+1];
ogg_dir[i+1]=ogg_dir[n];
ogg_dir[n]=ta;
}


} /* crap */







for(n=0;n<ogg_files;n++)
{
    dat[0]=ogg_dir[n]->title;
    dat[1]=ogg_dir[n]->artist;
    gtk_clist_append((GtkCList *)main_window_oggclist,dat);
}



gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[0]->title);
}

play_num=0;
gtk_widget_destroy(oggf);
return;
}






void
on_ogg_browse_ok_realize               (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_ogg_browse_cancel_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(oggf);
return;
}


void
on_ogg_browse_cancel_realize           (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_main_window_ogg_entry_realize       (GtkWidget       *widget,
                                        gpointer         user_data)
{
;
}


int ogg_file_count()
{
DIR *d=NULL;
int n;
char t[1000];
FILE *fptr1=NULL;
struct dirent *dent=NULL;
OggVorbis_File vf1;
int a;

n=0;
d=opendir(oggfiledir);
if(d==NULL)return 0;


while(1)
{
dent=readdir(d);
if(dent==NULL)break;
if(dent->d_name[0]!='.')
{
 strcpy(t,oggfiledir);
 if(t[strlen(t)-1]!='/')
 strcat(t,"/");
 strcat(t,dent->d_name);



   if((fptr1=fopen(t,"r"))!=NULL)
   {
      a=ov_open(fptr1, &vf1, NULL, 0);
      if(a>=0)
      {
        n++;
        ov_clear(&vf1);
      }
      else
     {
       fclose(fptr1);
       if(ismp3(t))
       n++;
       else
       if(iswav(t))
       n++;
     }


   }
}
}
   closedir(d);
   return n;
}




int isogg(char *b)
{
FILE *p;
OggVorbis_File vf;

if((p=fopen(b,"rb"))==NULL)return 0;
if(ov_open(p, &vf, NULL, 0) < 0) {fclose(p);return 0;}
ov_clear(&vf);
return 1;
}



void free_ogg_files()
{
int n;

for(n=0;n<ogg_files;n++)
{
 free(ogg_dir[n]->file_path);
 free(ogg_dir[n]->fname);
 free(ogg_dir[n]->title);
 free(ogg_dir[n]->artist);
 free(ogg_dir[n]);
}
free(ogg_dir);
ogg_files=0;
}




int play_ogg(int ofp)
{
FILE *fptr;
OggVorbis_File vf;
vorbis_info *vi;
char *ebuff;
int eof=0;
int current_section;
char pcmout[4096];




if((fptr=fopen(ogg_dir[ofp]->file_path,"rb"))==NULL)
{
if(!play_error)
{
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"Sonic-Rainbow cannot open file %s",ogg_dir[ofp]->file_path);
   do_error_message(ebuff);
   free(ebuff);
   }
   return 0;
}

ov_open(fptr, &vf, NULL, 0);
vi=ov_info(&vf,-1);

format.bits = 16;
format.channels = vi->channels;
format.rate = vi->rate;

format.byte_format = AO_FMT_LITTLE;
	ao_initialize();
	default_driver = ao_default_driver_id();
	device = ao_open_live(default_driver, &format, NULL /* no options */);
	if (device == NULL) {
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"Sonic-Rainbow cannot open Sound Driver");
fclose(fptr);
   do_error_message(ebuff);
   free(ebuff);
		return 0;
	}

	eof=0;

  while(!eof)
  {
    if(dowhat!=0)break;
    if(global_exit)break;
    if(pauseres==0)
    {
      long ret=ov_read(&vf,pcmout,4096,0,2,1,&current_section);
      gtk_main_iteration_do(FALSE);
       if (ret == 0)
       {
         /* EOF */
         eof=1;
       }
        else
        if (ret < 0)
        {
         /* error in the stream.  Not a problem, just reporting it in
	 case we (the app) cares.  In this case, we don't. */
        }
         else
         {
           /* we don't bother dealing with sample rate changes, etc, but
	   you'll have to*/
	   ao_play(device,pcmout, ret);
         }
      if(dowhat!=0)break;
      if(global_exit)break;
     }
    else
    {
      gtk_main_iteration_do(FALSE);
      if(dowhat!=0)break;
      if(global_exit)break;
    }
  }
ov_clear(&vf);
ao_close(device);
ao_shutdown();
device=NULL;
return 1;
}



void
on_main_window_newplaylist_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{
 cp=create_create_playlist_window();
  gtk_file_selection_set_filename ((GtkFileSelection *)cp,default_playlist_dir);
 gtk_widget_show(cp);
}



void
on_main_window_newplaylist_realize     (GtkWidget       *widget,
                                        gpointer         user_data)
{
;
}



void
on_main_window_delplaylist_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{

 isok=0;
 ismod=1;
 dw=create_delete_playlist_window ();
 gtk_file_selection_set_filename ((GtkFileSelection *)dw,default_playlist_dir);
 gtk_widget_show(dw);
}



void
on_main_window_delplaylist_realize     (GtkWidget       *widget,
                                        gpointer         user_data)
{

}



void
on_main_window_modplaylist_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{
 mp=create_mod_playlist_window();

 ismod=1;
 isok=0;
 psel=-1;
 gtk_widget_show(mp);
}


void
on_main_window_modplaylist_realize     (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_main_window_loadplaylist_clicked    (GtkButton       *button,
                                        gpointer         user_data)
{
 lp=create_main_window_loadplaylistfile ();
 gtk_file_selection_set_filename ((GtkFileSelection *)lp,default_playlist_dir);
 gtk_widget_show(lp);
}


void
on_main_window_loadplaylist_realize    (GtkWidget       *widget,
                                        gpointer         user_data)
{

}

void
on_main_window_loadplaylist_ok_clicked (GtkButton       *button,
                                        gpointer         user_data)
{

char b[1000];


 strcpy(b,gtk_file_selection_get_filename ((GtkFileSelection *)lp));
 if(b[strlen(b)-1]!='/')
 {
  load_play(b);
 }

gtk_widget_destroy(lp);
}


void
on_main_window_loadplaylist_canel_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(lp);
}


int  load_play(char bu[])
{
FILE *fptr,*fptr1,*fptr2;
char t[1000];
DIR *d;
char *ebuff;
struct id3_file *id3_f=NULL;
struct id3_tag *id3_t=NULL;
struct id3_frame *fr=NULL;
id3_latin1_t *b=NULL;

struct dirent *dent;
char *dat[2],*token;
OggVorbis_File vf;
struct oggdir *ta;

int num=0;
int n=0;
int i=0;
int j=0;


gtk_clist_clear((GtkCList*)main_window_oggclist);



if(ogg_files)
free_ogg_files();

ogg_files=0;

if((fptr=fopen(bu,"rb"))==NULL)
{
   ebuff=(char *)malloc(5000);
sprintf(ebuff,"Sonic-Rainbow cannot open Playlist %s",bu);
   do_error_message(ebuff);
   free(ebuff);
   return 0;
}
fgets(t,900,fptr); /* Sonic-Rainbow Header */



while(1)
{
 if((fgets(t,900,fptr))==NULL)break;
 if(t[strlen(t)-1]==10)
 t[strlen(t)-1]=0;
 if((d=opendir(t))!=NULL)
 {
  closedir(d);
  strcpy(oggfiledir,t);
  num=num + ogg_file_count();
 }
 else
 if(isogg(t))
 num++;
 else
 if(iswav(t))
 num++;
 else
 if(ismp3(t))
 num++;
}
fclose(fptr);


ogg_files=num;
n=0;

if(ogg_files!=0)
{
ogg_dir=(struct oggdir **)calloc(ogg_files,sizeof(struct oggdir *));
}
else
ogg_dir=NULL;



if((fptr1=fopen(bu,"rb"))==NULL)
{
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"Sonic-Rainbow cannot open Playlist %s",bu);
   do_error_message(ebuff);
   free(ebuff);
   return 0;
}


fgets(t,900,fptr1); /* Sonic-Rainbow Header */



while(1)
{
 if((fgets(t,900,fptr1))==NULL)break;
  if(t[strlen(t)-1]==10)
   t[strlen(t)-1]=0;

 if((d=opendir(t))!=NULL)/* fill dir */
 {
  strcpy(oggfiledir,t);
  if(t[strlen(t)-1]!='/')
  strcat(oggfiledir,"/");
  while(1)
  {
   dent=readdir(d);
  if(dent==NULL)break;
  if(dent->d_name[0]!='.')
  {

   strcpy(t,oggfiledir);
   strcat(t,dent->d_name);


if(iswav(t))
{
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;
    ogg_dir[n]->title=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->title,"Unknown");
    ogg_dir[n]->artist=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->artist,"Unknown");
    n++;
}
else
   if((fptr=fopen(t,"rb"))!=NULL)
   {
   if(ov_open(fptr, &vf, NULL, 0)>=0)
   {
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(dent->d_name)+1);
    strcpy(ogg_dir[n]->fname,dent->d_name);

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;
       for(i=0;i<vf.vc->comments;i++)
        {
             if(strncasecmp("title=",vf.vc->user_comments[i],6)==0)
               {

                 token=strtok(vf.vc->user_comments[i],"=");
                token=strtok(NULL,"");
                ogg_dir[n]->title=(char *)malloc(strlen(token)+1);
               strcpy(ogg_dir[n]->title,token);
              dat[0]=ogg_dir[n]->title;
               }
               else
              if(strncasecmp("artist=",vf.vc->user_comments[i],6)==0)
              {
               token=strtok(vf.vc->user_comments[i],"=");
               token=strtok(NULL,"");
               ogg_dir[n]->artist=(char *)malloc(strlen(token)+1);
               strcpy(ogg_dir[n]->artist,token);
               dat[1]=ogg_dir[n]->artist;
              }

         }


 n++;
 ov_clear(&vf);
  }
  else
  {
    fclose(fptr);
       if(ismp3(t))
    {
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);
   id3_f=id3_file_open(t,ID3_FILE_MODE_READONLY);
    if(id3_f!=NULL)
    {
     id3_t= id3_file_tag(id3_f);
      if(id3_t!=NULL)
      {
          fr=id3_tag_findframe(id3_t,"TIT2",0);
	  if(fr!=NULL)
	  {
	  if(fr->fields[1].type==4 || fr->fields[1].type==5 ||fr->fields[1].type==6 )
	  {
	  b=id3_ucs4_latin1duplicate(fr->fields[1].stringlist.strings[0]);
	  ogg_dir[n]->title=(char *)malloc(strlen(b)+1);
          strcpy(ogg_dir[n]->title,b);
	  free(b);
	  }
	  else
	  {
           ogg_dir[n]->title=(char *)malloc(strlen((char*)fr->fields[1].stringlist.strings[0])+1);
           strcpy(ogg_dir[n]->title,(char*)fr->fields[1].stringlist.strings[0]);
	   }
	  }


          fr=id3_tag_findframe(id3_t,"TPE1",0);
          if(fr!=NULL)
	  {
	   if(fr->fields[1].type==4 || fr->fields[1].type==5 ||fr->fields[1].type==6 )
	   {
	   b=id3_ucs4_latin1duplicate(fr->fields[1].stringlist.strings[0]);
	   ogg_dir[n]->artist=(char *)malloc(strlen(b)+1);
           strcpy(ogg_dir[n]->artist,b);
	   free(b);
	   }
	   else
	   {
            ogg_dir[n]->artist=(char *)malloc(strlen((char*)fr->fields[1].stringlist.strings[0])+1);
            strcpy(ogg_dir[n]->artist,(char*)fr->fields[1].stringlist.strings[0]);
	   }
	  }

      }  /* id3_t !=NULL */
    } /* id3 !=NULL */

         if(ogg_dir[n]->title==NULL)
         {
           ogg_dir[n]->title=(char *)malloc(strlen("Unknown")+1);
           strcpy(ogg_dir[n]->title,"Unknown");
         }

           if(ogg_dir[n]->artist==NULL)
           {
             ogg_dir[n]->artist=(char *)malloc(strlen("Unknown")+1);
             strcpy(ogg_dir[n]->artist,"Unknown");
            }

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;
    n++;
    }
  }

 }



}
}

  closedir(d);

for(;j<n;j++)
for(i=j;i<n-1;i++)
{
if(strcmp(ogg_dir[j]->file_path,ogg_dir[i+1]->file_path)>0)
{
ta=ogg_dir[i+1];
ogg_dir[i+1]=ogg_dir[j];
ogg_dir[j]=ta;
}
}


}



 else
  if(ismp3(t))
   {
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);
   id3_f=id3_file_open(t,ID3_FILE_MODE_READONLY);
    if(id3_f!=NULL)
    {
     id3_t= id3_file_tag(id3_f);
      if(id3_t!=NULL)
      {
          fr=id3_tag_findframe(id3_t,"TIT2",0);
	  if(fr!=NULL)
	  {
	  if(fr->fields[1].type==4 || fr->fields[1].type==5 ||fr->fields[1].type==6 )
	  {
	  b=id3_ucs4_latin1duplicate(fr->fields[1].stringlist.strings[0]);
	  ogg_dir[n]->title=(char *)malloc(strlen(b)+1);
          strcpy(ogg_dir[n]->title,b);
	  free(b);
	  }
	  else
	  {
           ogg_dir[n]->title=(char *)malloc(strlen((char*)fr->fields[1].stringlist.strings[0])+1);
           strcpy(ogg_dir[n]->title,(char*)fr->fields[1].stringlist.strings[0]);
	   }
	  }


          fr=id3_tag_findframe(id3_t,"TPE1",0);
          if(fr!=NULL)
	  {
	   if(fr->fields[1].type==4 || fr->fields[1].type==5 ||fr->fields[1].type==6 )
	   {
	   b=id3_ucs4_latin1duplicate(fr->fields[1].stringlist.strings[0]);
	   ogg_dir[n]->artist=(char *)malloc(strlen(b)+1);
           strcpy(ogg_dir[n]->artist,b);
	   free(b);
	   }
	   else
	   {
            ogg_dir[n]->artist=(char *)malloc(strlen((char *)fr->fields[1].stringlist.strings[0])+1);
            strcpy(ogg_dir[n]->artist,(char*)fr->fields[1].stringlist.strings[0]);
	   }
	  }

      }  /* id3_t !=NULL */
    } /* id3 !=NULL */

if(ogg_dir[n]->title==NULL)
{
    ogg_dir[n]->title=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->title,"Unknown");
}

if(ogg_dir[n]->artist==NULL)
{
    ogg_dir[n]->artist=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->artist,"Unknown");
}
    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;
    n++;
    j++;
    }
 else
if(iswav(t))
{
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;
    ogg_dir[n]->title=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->title,"Unknown");
    ogg_dir[n]->artist=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->artist,"Unknown");
    n++;
}
else
 if(isogg(t))
 {

    if((fptr2=fopen(t,"rb"))!=NULL)
   {

   if(ov_open(fptr2, &vf, NULL, 0)>=0)
   {
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;


       for(i=0;i<vf.vc->comments;i++)
        {
             if(strncasecmp("title=",vf.vc->user_comments[i],6)==0)
               {

                 token=strtok(vf.vc->user_comments[i],"=");
                token=strtok(NULL,"");
                ogg_dir[n]->title=(char *)malloc(strlen(token)+1);
               strcpy(ogg_dir[n]->title,token);
              dat[0]=ogg_dir[n]->title;
               }
               else
              if(strncasecmp("artist=",vf.vc->user_comments[i],6)==0)
              {
               token=strtok(vf.vc->user_comments[i],"=");
               token=strtok(NULL,"");
               ogg_dir[n]->artist=(char *)malloc(strlen(token)+1);
               strcpy(ogg_dir[n]->artist,token);
               dat[1]=ogg_dir[n]->artist;
              }

         }


 n++;
 j++;
 ov_clear(&vf);
  }
  else
  {
    fclose(fptr2);
  }

 }

  /* fill one struct */
 }




} /* end of while loop */
fclose(fptr1);



ogg_files=n;



if(ogg_files>0)
{

for(n=0;n<ogg_files;n++)
{
    dat[0]=ogg_dir[n]->title;
    dat[1]=ogg_dir[n]->artist;
    dat[2]=NULL;
    gtk_clist_append((GtkCList *)main_window_oggclist,dat);
}

if(n==0)
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,"");
else
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[0]->title);
}

play_num=0;
return 1;
}






void
on_create_playlist_window_fixed_realize
                                        (GtkWidget       *widget,
                                        gpointer         user_data)
{

}





void
on_create_playlist_direntry_realize    (GtkWidget       *widget,
                                        gpointer         user_data)
{
playlist_direntry=widget;
gtk_entry_set_text((GtkEntry *)playlist_direntry,default_playlist_dir);
}




void
on_create_playlist_fileentry_realize   (GtkWidget       *widget,
                                        gpointer         user_data)
{
fentry=widget;
}






void
on_create_playlist_browse_button_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
ismod=0;
 bpa=create_general_file_window ();
 gtk_file_selection_set_filename ((GtkFileSelection *)bpa,default_playlist_dir);
 gtk_widget_show(bpa);
}





void
on_create_playlist_list_realize        (GtkWidget       *widget,
                                        gpointer         user_data)
{
create_plist=widget;
psel=-1;
gtk_clist_set_column_auto_resize((GtkCList *)widget,0,1);
}





void
on_create_playlist_add_button_clicked  (GtkButton       *button,
                                        gpointer         user_data)
{
 cpa=create_create_playlist_add_filedir();
 gtk_file_selection_set_filename ((GtkFileSelection *)cpa,music_dir);
 gtk_widget_show(cpa);
}




void
on_create_playlist_exit_button_clicked (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(cp);
}





int
on_create_playlist_save_button_clicked (GtkButton       *button,
                                        gpointer         user_data)
{
char *a=NULL;
char *b=NULL;
char *p,*t;
FILE *fptr;
int count=0;
char *ebuff;

a=gtk_entry_get_text((GtkEntry*)fentry);
b=gtk_entry_get_text((GtkEntry*)playlist_direntry);



if(strlen(a)!=0 && strlen(b)!=0)
{
p=(char*)malloc(strlen(a)+strlen(b)+2);
strcpy(p,b);

if(p[strlen(p)-1]!='/')strcat(p,"/");
strcat(p,a);

if((fptr=fopen(p,"wb"))==NULL)
{
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"Sonic-Rainbow cannot create Playlist %s",p);
   do_error_message(ebuff);
   free(ebuff);
   return 0;
}


fprintf(fptr,"Sonic-Rainbow Playlist\n");
while(1)
{
if((gtk_clist_get_text((GtkCList*)create_plist,count,0,&t))==0)
break;
fprintf(fptr,"%s\n",t);
count++;
}

fclose(fptr);
free(p);
return 1;
}
return 0;

}





void
on_create_playlist_cancel_button_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{

}





void
on_ok_button1_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
char *t;
if(ismod)
{
t=gtk_file_selection_get_filename ((GtkFileSelection *)mpb);
 if(t[strlen(t)-1]=='/')
return;

ismod=0;
gtk_entry_set_text((GtkEntry *)mod_playlist_direntry,t);
gtk_widget_destroy(mpb);
on_mod_playlist_load_clicked  (NULL,NULL);
return;
}



t=gtk_file_selection_get_filename ((GtkFileSelection *)bpa);
if(t[strlen(t)-1]!='/')
{
gtk_file_selection_set_filename ((GtkFileSelection *)bpa,"");
return;
}
gtk_entry_set_text((GtkEntry *)playlist_direntry,gtk_file_selection_get_filename ((GtkFileSelection *)bpa));
gtk_widget_destroy(bpa);
}




void
on_cancel_button1_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
if(ismod)
{
ismod=0;
gtk_widget_destroy(mpb);
return;
}
gtk_widget_destroy(bpa);
return;
}






void
on_ok_button2_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
char *dat[3];

if(ismod)
{
dat[1]=NULL;
dat[0]=gtk_file_selection_get_filename ((GtkFileSelection *)mpa);
gtk_clist_append((GtkCList *)create_plist,dat);
gtk_widget_destroy(mpa);
ismod=0;
return;
}

dat[1]=NULL;
dat[0]=gtk_file_selection_get_filename ((GtkFileSelection *)cpa);
gtk_clist_append((GtkCList *)create_plist,dat);
gtk_widget_destroy(cpa);
}





void
on_cancel_button2_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
if(ismod)
{
gtk_widget_destroy(mpa);
ismod=0;
return;
}
gtk_widget_destroy(cpa);
}





void
on_create_playlist_del_button_clicked  (GtkButton       *button,
                                        gpointer         user_data)
{

gtk_clist_remove((GtkCList *)create_plist,psel);
return;

}






void
on_create_playlist_list_select_row     (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
psel=row;
}

void
on_create_playlist_list_unselect_row   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
psel=-1;
}






void
on_mod_playlist_fixed_realize          (GtkWidget       *widget,
                                        gpointer         user_data)
{

}






void
on_mod_playlist_list_realize           (GtkWidget       *widget,
                                        gpointer         user_data)
{
create_plist=widget;
psel=-1;
gtk_clist_set_column_auto_resize((GtkCList *)widget,0,1);
}






void
on_mod_playlist_list_select_row        (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
psel=row;
}



void
on_mod_playlist_list_unselect_row      (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
psel=-1;
}


void
on_mod_playlist_add_button_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{

 ismod=1;
 mpa=create_create_playlist_add_filedir();
 gtk_file_selection_set_filename ((GtkFileSelection *)mpa,music_dir);
 gtk_widget_show(mpa);
}



void
on_mod_playlist_remove_button_clicked  (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_clist_remove((GtkCList *)create_plist,psel);
return;
}




void
on_mod_playlist_direntry_realize       (GtkWidget       *widget,
                                        gpointer         user_data)
{
mod_playlist_direntry=widget;
}



void
on_mod_playlist_fileentry_realize      (GtkWidget       *widget,
                                        gpointer         user_data)
{
fentry=widget;
}



void
on_mod_playlist_browse_button_clicked  (GtkButton       *button,
                                        gpointer         user_data)
{
char *a;
char *f;

 isok=0;
 ismod=1;

 mpb=create_general_file_window ();
 gtk_file_selection_set_filename ((GtkFileSelection *)mpb,default_playlist_dir);
 gtk_widget_show(mpb);
 return;

a=gtk_file_selection_get_filename ((GtkFileSelection *)gw);

if(a[strlen(a)-1]=='/')
return;

f=gtk_file_selection_get_filename ((GtkFileSelection *)gw);

gtk_entry_set_text((GtkEntry *)playlist_direntry,f);
gtk_widget_destroy(gw);
return;


if(isok)
{
gtk_entry_set_text((GtkEntry *)playlist_direntry,gtk_file_selection_get_filename ((GtkFileSelection *)gw));
}

isok=0;
ismod=0;
 gtk_widget_destroy(gw);

}


void
on_mod_playlist_exit_button_clicked    (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(mp);
}



int on_mod_playlist_save_button_clicked    (GtkButton       *button,
                                        gpointer         user_data)
{
char *b=NULL;
char *t;
FILE *fptr;
int count=0;
char *ebuff;

b=gtk_entry_get_text((GtkEntry*)mod_playlist_direntry);

if((fptr=fopen(b,"wb"))==NULL)
{
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"Sonic-Rainbow cannot modify Playlist %s",b);
   do_error_message(ebuff);
   free(ebuff);
   return 0;
}

fprintf(fptr,"Sonic-Rainbow Playlist");

while(1)
{
if((gtk_clist_get_text((GtkCList*)create_plist,count,0,&t))==0)
break;
fprintf(fptr,"\n%s",t);
count++;
}

fclose(fptr);
return 1;

}







void
on_mod_playlist_cancel_button_clicked  (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(mp);
}




int on_mod_playlist_load_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
char *b=NULL;
FILE *fptr;
char tb[1000];
char *dat[3];
char *ebuff;


b=gtk_entry_get_text((GtkEntry*)mod_playlist_direntry);


if((fptr=fopen(b,"rb"))==NULL)
{
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"Sonic-Rainbow cannot Load Playlist %s",b);
   do_error_message(ebuff);
   free(ebuff);
   return 0;
}
fgets(tb,990,fptr);
gtk_clist_clear((GtkCList*)create_plist);

while(1)
{
if((fgets(tb,990,fptr))==NULL)break;
tb[strlen(tb)-1]=0;
dat[1]=NULL;
dat[0]=tb;
gtk_clist_append((GtkCList *)create_plist,dat);
}


fclose(fptr);
return 1;
}




void
on_playlist_delete_button_clicked      (GtkButton       *button,
                                        gpointer         user_data)
{
remove(gtk_file_selection_get_filename ((GtkFileSelection *)dw));
gtk_widget_destroy(dw);
}


void
on_delete_playlist_window_realize      (GtkWidget       *widget,
                                        gpointer         user_data)
{
dw=widget;
}


void
on_playlist_cancel_button_clicked      (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(dw);
}

struct buffer {
  unsigned char const *start;
  unsigned long length;
};



static int decode(unsigned char const *start, unsigned long length)
{
  struct buffer buffer;
  struct mad_decoder decoder;
  int result;

  /* initialize our private message structure */

  buffer.start  = start;
  buffer.length = length;

  /* configure input, output, and error functions */

  mad_decoder_init(&decoder, &buffer,
		   input, 0 /* header */, 0 /* filter */, output,
		   error, 0 /* message */);

  /* start decoding */

  result = mad_decoder_run(&decoder, MAD_DECODER_MODE_SYNC);

  /* release the decoder */

  mad_decoder_finish(&decoder);

  return result;
}

static enum mad_flow input(void *data,struct mad_stream *stream)
{
  struct buffer *buffer = data;

  if (!buffer->length)
    return MAD_FLOW_STOP;

  mad_stream_buffer(stream, buffer->start, buffer->length);

  buffer->length = 0;

  return MAD_FLOW_CONTINUE;
}

static inline signed int scale(mad_fixed_t sample)
{
  /* round */
  sample += (1L << (MAD_F_FRACBITS - 16));

  /* clip */
  if (sample >= MAD_F_ONE)
    sample = MAD_F_ONE - 1;
  else if (sample < -MAD_F_ONE)
    sample = -MAD_F_ONE;

  /* quantize */
  return sample >> (MAD_F_FRACBITS + 1 - 16);
}

static enum mad_flow error(void *data,struct mad_stream *stream,struct mad_frame *frame)
{
  return MAD_FLOW_BREAK;
}



int play_mpeg(char mp3[])
{
 struct stat stat;
 void *fdm;
 FILE *mpg;
 char *ebuff;

if((mpg=fopen(mp3,"rb"))==NULL)
{
if(!play_error)
{
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"Sonic-Rainbow cannot open File\n%s\nThis may be a permissions based problem",mp3);
   do_error_message(ebuff);
   free(ebuff);
}
return -1;
}

   if(device!=NULL)
   {
   ao_close(device);
   ao_shutdown();
   device=NULL;
   }

if(mpg==NULL)return 0;

   if (fstat(fileno(mpg), &stat) == -1 ||
      stat.st_size == 0) return -1;

  fdm = mmap(0, stat.st_size, PROT_READ, MAP_SHARED,fileno(mpg) , 0);

  fclose(mpg);

  if (fdm == MAP_FAILED)
  {
  return -2;
}

  decode(fdm, stat.st_size);


if(device!=NULL)
{
   ao_close(device);
   ao_shutdown();
   device=NULL;
}



  if (munmap(fdm, stat.st_size) == -1)
  {
    return -3;
    }

return 0;
}





static
enum mad_flow output(void *data,
		     struct mad_header const *header,
		     struct mad_pcm *pcm)
{
  unsigned int nchannels, nsamples;
  mad_fixed_t const *left_ch, *right_ch;


  nchannels = pcm->channels;
  nsamples  = pcm->length;
  left_ch   = pcm->samples[0];
  right_ch  = pcm->samples[1];
 char b[4];



if(device==NULL)
{
   ao_initialize();
   default_driver = ao_default_driver_id();
   format.bits =16;
   format.channels = pcm->channels;
   format.rate = pcm->samplerate;
   format.byte_format = AO_FMT_LITTLE;
   device = ao_open_live(default_driver, &format, NULL );
   if(device==NULL)return MAD_FLOW_STOP;
}



  while (nsamples--) {
    signed int sample;

    /* output sample(s) in 16-bit signed little-endian PCM */

    sample = scale(*left_ch++);

 b[0]=(sample >> 0) & 0xff;
 b[1]=(sample >> 8) & 0xff;

    if (nchannels == 2) {
      sample = scale(*right_ch++);
      b[2]=(sample >> 0) & 0xff;
      b[3]=(sample >> 8) & 0xff;
      }
      else
      {
      b[0]=b[2];
      b[1]=b[3];
      }

 ao_play(device, b, 4);

 gtk_main_iteration_do(FALSE);
if(dowhat!=0|| global_exit)
{
return MAD_FLOW_STOP;
}
  }
  return MAD_FLOW_CONTINUE;
}


int isplaylist(char *fn)
{
FILE *f;
char b[80];

if((f=fopen(fn,"rb"))==NULL)return 0;
if((fgets(b,79,f))==NULL){fclose(f);return 0;}
fclose(f);
b[strlen(b)-1]=0;

if(strcmp(b,"Sonic-Rainbow Playlist")==0)return 1;
return 0;
}


int ismp3(char *fn)
{
 char *p;
 if(strlen(fn)<5)return 0;
 p=fn+strlen(fn)-3;
 if(strcasecmp(p,"mp3")==0)return 1;
 else
 return 0;
}


int iswav(char *fn)
{
AFfilehandle	file;
int a,v;


file = afOpenFile(fn, "r", NULL);
a=afGetFileFormat (file, &v);
afCloseFile(file);
if(a==AF_FILE_WAVE)
return 1;
else
return 0;
}


void play_wav(char *fn)
{
	AFfilehandle	file;
	AFframecount	frameCount, framesRead;
	int		sampleFormat, sampleWidth, channelCount;
	float		frameSize;
	void		*buffer;
int a,v;


	file = afOpenFile(fn, "r", NULL);
a=afGetFileFormat (file, &v);

if(a!=AF_FILE_WAVE)
{
afCloseFile(file);
return;
}
	frameCount = afGetFrameCount(file, AF_DEFAULT_TRACK);

	channelCount = afGetVirtualChannels(file, AF_DEFAULT_TRACK);
	afGetVirtualSampleFormat(file, AF_DEFAULT_TRACK, &sampleFormat,
		&sampleWidth);

	frameSize = afGetVirtualFrameSize(file, AF_DEFAULT_TRACK, 1);


	if ((sampleFormat != AF_SAMPFMT_TWOSCOMP) &&
		(sampleFormat != AF_SAMPFMT_UNSIGNED))
	{
afCloseFile(file);
return;
	}

	if ((sampleWidth != 16) || (channelCount > 2))
	{
afCloseFile(file);
return;
	}

	buffer = malloc(4096 * frameSize);

   if(device!=NULL)
   {
   ao_close(device);
   ao_shutdown();
   device=NULL;
   }

format.bits = 16;
format.channels = channelCount;
format.rate = 44100;

format.byte_format = AO_FMT_LITTLE;
	ao_initialize();
	default_driver = ao_default_driver_id();
	device = ao_open_live(default_driver, &format, NULL /* no options */);

	framesRead = afReadFrames(file, AF_DEFAULT_TRACK, buffer,
		4096);

	while (framesRead > 0)
	{
  while (gtk_events_pending ())
       gtk_main_iteration_do(FALSE);
      if(dowhat!=0)break;
      if(global_exit)break;
ao_play(device,buffer,framesRead * frameSize);

		framesRead = afReadFrames(file, AF_DEFAULT_TRACK, buffer,
			4096);
	}

afCloseFile(file);
	free(buffer);
   ao_close(device);
   ao_shutdown();
   device=NULL;
}
