/*
Sonic Rainbow written by Gary Baker South Australia.
Copyright (C) 2003 Gary Baker

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <string.h>
#include <malloc.h>
#include <unistd.h>
#include <linux/soundcard.h>
#include <ao/ao.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <mad.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/mman.h>

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "cd.h"
#include <sys/types.h>
#include <dirent.h>
#include <vorbis/vorbisfile.h>
#include <vorbis/codec.h>
#include <mad.h>
#include <id3tag.h>
#include <linux/videodev.h>
#include <math.h>

extern int display_radio,fm_autoplay;
extern char default_radio[1000];
extern GtkWidget *sta,*main_fixed,*mwin;
extern GtkObject *sadj;
extern GtkTooltips *stip;
extern float frequencys[11];
extern char  blabels[11][7];


extern GtkWidget *bt1,*bt2,*bt3,*bt4,*bt5,*bt6,*bt7,*bt8,*bt9,*bt10,*radprog,*radplay,*radstop;
extern GtkWidget *vt1,*vt2,*vt3,*vt4,*rlab,*flabel,*freq_spin;
extern GtkWidget *radsave_window,*save_list,*save_spin,*save_entry;

extern GtkObject *freq_spin_adj;
int radio_dev=-1;
int rowsel=-1;

void main_f( GtkAdjustment *get, gpointer         user_data );

void radio_buttons();
void do_save_config();
void reset_radio_button(int but);
void do_error_message(char *text);

#define TRIES 1 /* get 25 samples                 */
#define LOCKTIME 100000 /* wait 400ms for card to lock on */
#define SAMPLEDELAY 0		/* wait 15ms between samples      */
#define THRESHOLD .5    /* minimum acceptable signal %    */
struct video_audio va;
struct video_tuner vt;
float fact;







void
on_station_1_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
unsigned long freq;


freq=ceil(frequencys[0] * fact);
ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va); 
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,frequencys[0]);
}



void
on_station_2_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
unsigned long freq;

freq=ceil(frequencys[1] * fact);
ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,frequencys[1]);
}


void
on_station_3_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
unsigned long freq;


freq=ceil(frequencys[2] * fact);
ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,frequencys[2]);
}


void
on_station_4_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
unsigned long freq;


freq=ceil(frequencys[3] * fact);
ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,frequencys[3]);
}


void
on_station_5_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
unsigned long freq;


freq=ceil(frequencys[4] * fact);
ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,frequencys[4]);
}


void
on_station_6_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
unsigned long freq;


freq=ceil(frequencys[5] * fact);
ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,frequencys[5]);
}


void
on_station_7_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
unsigned long freq;


freq=ceil(frequencys[6] * fact);
ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,frequencys[6]);
}


void
on_station_8_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
unsigned long freq;


freq=ceil(frequencys[7] * fact);
ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,frequencys[7]);
}


void
on_statio_9_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
unsigned long freq;


freq=ceil(frequencys[8] * fact);
ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,frequencys[8]);
}


void
on_station_10_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
unsigned long freq;


freq=ceil(frequencys[9] * fact);
ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,frequencys[9]);
}


void
on_play_radio_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
int ret;
unsigned long freq;
char *ebuff;
if(radio_dev==-2)return;

if(radio_dev==-1)
{
radio_dev=open(default_radio,O_RDWR);
if(radio_dev==-1)
{
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"Errors accesing the Radio Device\nSonic-Rainbow needs to be able to read and write\nto the Radio device file. Your radio device has\nbeen configured as %s\nThis is most likely a file permissions based\nproblem that can be resolved by changing the\npermissions on %s\nor changing the runtime permissions of\nSonic-Rainbow",default_radio,default_radio);
   do_error_message(ebuff);
   free(ebuff);
radio_dev=-2;
return;
}



ret = ioctl(radio_dev, VIDIOCGAUDIO, &va);

vt.tuner=0;
ret = ioctl(radio_dev, VIDIOCSTUNER, &vt);	/* set tuner # */


ret = ioctl(radio_dev, VIDIOCGTUNER, &vt);	/* get frequency range */

if ((ret == -1) || ((vt.flags & VIDEO_TUNER_LOW) == 0))
fact = 16;
else
fact = 16000;

if(freq_spin!=NULL)
freq = ceil(gtk_spin_button_get_value_as_float((GtkSpinButton*)freq_spin) * fact);
else
freq=ceil(frequencys[10] *fact);

ret = ioctl(radio_dev, VIDIOCSFREQ, &freq);

va.audio = 0;
va.volume = 0;
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ret = ioctl(radio_dev, VIDIOCSAUDIO, &va);
}

}




void
on_stop_radio_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
va.audio = 0;
va.volume = 0;
va.flags = VIDEO_AUDIO_MUTE;
ioctl(radio_dev, VIDIOCSAUDIO, &va);

close(radio_dev);
radio_dev=-1;
}


void
on_radio_program_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
radsave_window=create_radio_save_window();
gtk_widget_show(radsave_window);
gtk_main();
}



void
on_play_radio_realize                  (GtkWidget       *widget,
                                        gpointer         user_data)
{
;
}


void
on_stop_radio_realize                  (GtkWidget       *widget,
                                        gpointer         user_data)
{
radstop=widget;
}


void
on_radio_program_realize               (GtkWidget       *widget,
                                        gpointer         user_data)
{
radprog=widget;

}

void
on_vseparator6_realize                 (GtkWidget       *widget,
                                        gpointer         user_data)
{
vt1=widget;
}


void
on_hseparator6_realize                 (GtkWidget       *widget,
                                        gpointer         user_data)
{
vt2=widget;
}


void
on_vseparator5_realize                 (GtkWidget       *widget,
                                        gpointer         user_data)
{
vt3=widget;
}


void
on_hseparator5_realize                 (GtkWidget       *widget,
                                        gpointer         user_data)
{
vt4=widget;
}


void
on_label26_realize                     (GtkWidget       *widget,
                                        gpointer         user_data)
{
rlab=widget;
}

void
on_freq_spin_changed                   (GtkEditable     *editable,
                                        gpointer         user_data)
{
float fl=0;
char buf[1000];
unsigned long freq;
static int b=0;
char *ebuff;

if(radio_dev==-2)
{
if(b==1)return;
b=1;
gtk_signal_handler_block_by_func((GtkObject *)sadj,main_f,NULL);
gtk_signal_handler_block_by_func((GtkObject *)freq_spin,on_freq_spin_changed,NULL);
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"Errors accesing the Radio Device\nSonic-Rainbow needs to be able to read and write\nto the Radio device file to alter the frequency.\nYour radio device has been configured as\n%s.\nThis is most likely a file permissions based\nproblem that can be resolved by changing the\npermissions on %s\nor changing the runtime permissions of\nSonic-Rainbow.\nThis message will only be displayed once",default_radio,default_radio);
   do_error_message(ebuff);
   free(ebuff);
b=1;
gtk_signal_handler_unblock_by_func((GtkObject *)sadj,main_f,NULL);
gtk_signal_handler_unblock_by_func((GtkObject*)freq_spin,on_freq_spin_changed,NULL);
return;

}


fl=gtk_spin_button_get_value_as_float((GtkSpinButton*)freq_spin);
sprintf(buf,"%-2.1f",fl);

gtk_signal_handler_block_by_func((GtkObject *)sadj,main_f,NULL);

gtk_adjustment_set_value((GtkAdjustment *)sadj,atof(buf)*10);

gtk_signal_handler_unblock_by_func((GtkObject *)sadj,main_f,NULL);
if(radio_dev!=-1)
{
freq= ceil(atof(buf) * fact);

ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;/*tunevol;*/
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
}

}


void
on_freq_spin_realize                   (GtkWidget       *widget,
                                        gpointer         user_data)
{
freq_spin=widget;
}


void
on_station_lable_realize               (GtkWidget       *widget,
                                        gpointer         user_data)
{
flabel=widget;
}

void main_f( GtkAdjustment *get, gpointer         user_data )
{
float b=0;
char buf[1000];
unsigned long freq;
static int ba=0;
char *ebuff;


if(radio_dev==-2)
{
if(ba==1)return;
ba=1;
gtk_signal_handler_block_by_func((GtkObject *)sadj,main_f,NULL);
gtk_signal_handler_block_by_func((GtkObject *)freq_spin,on_freq_spin_changed,NULL);
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"Errors accesing the Radio Device\nSonic-Rainbow needs to be able to read and write\nto the Radio device file to alter the frequency.\nYour radio device has been configured as\n%s.\nThis is most likely a file permissions based\nproblem that can be resolved by changing the\npermissions on %s\nor changing the runtime permissions of\nSonic-Rainbow.\nThis message will only be displayed once",default_radio,default_radio);
   do_error_message(ebuff);
   free(ebuff);
ba=1;
gtk_signal_handler_unblock_by_func((GtkObject *)sadj,main_f,NULL);
gtk_signal_handler_unblock_by_func((GtkObject*)freq_spin,on_freq_spin_changed,NULL);
return;

}


gtk_signal_handler_block_by_func((GtkObject *)freq_spin,on_freq_spin_changed,NULL);
b=(float)get->value/10;
sprintf(buf,"%-2.1f",b);
gtk_tooltips_set_tip((GtkTooltips*)stip,sta,buf,NULL);
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,atof(buf));
gtk_signal_handler_unblock_by_func((GtkObject*)freq_spin,on_freq_spin_changed,NULL);
if(radio_dev!=-1)
{
freq= ceil(atof(buf) * fact);

ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;/*tunevol;*/
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
}
}



void radio_buttons()
{
/*
char nb[1000];
  bt1 = gtk_button_new_with_label (blabels[0]);
  gtk_widget_ref (bt1);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_1", bt1,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed),bt1, 120, 386);
  gtk_widget_set_uposition (bt1, 120, 386);
  gtk_widget_set_usize (bt1, 54, 22);

  bt2 = gtk_button_new_with_label (blabels[1]);
  gtk_widget_ref (bt2);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_2", bt2,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), bt2, 184, 386);
  gtk_widget_set_uposition (bt2, 184, 386);
  gtk_widget_set_usize (bt2, 54, 22);

  bt3 = gtk_button_new_with_label (blabels[2]);
  gtk_widget_ref (bt3);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_3", bt3,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), bt3, 248, 386);
  gtk_widget_set_uposition (bt3, 248, 386);
  gtk_widget_set_usize (bt3, 54, 22);

  bt4 = gtk_button_new_with_label (blabels[3]);
  gtk_widget_ref (bt4);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_4", bt4,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), bt4, 312, 386);
  gtk_widget_set_uposition (bt4, 312, 386);
  gtk_widget_set_usize (bt4, 54, 22);

  bt5 = gtk_button_new_with_label (blabels[4]);
  gtk_widget_ref (bt5);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_5", bt5,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), bt5, 376, 386);
  gtk_widget_set_uposition (bt5, 376, 386);
  gtk_widget_set_usize (bt5, 54, 22);

  bt6 = gtk_button_new_with_label (blabels[5]);
  gtk_widget_ref (bt6);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_6", bt6,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), bt6, 120, 416);
  gtk_widget_set_uposition (bt6, 120, 416);
  gtk_widget_set_usize (bt6, 54, 22);

  bt7 = gtk_button_new_with_label (blabels[6]);
  gtk_widget_ref (bt7);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_7", bt7,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), bt7, 184, 416);
  gtk_widget_set_uposition (bt7, 184, 416);
  gtk_widget_set_usize (bt7, 54, 22);

  bt8 = gtk_button_new_with_label (blabels[7]);
  gtk_widget_ref (bt8);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_8", bt8,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), bt8, 248, 416);
  gtk_widget_set_uposition (bt8, 248, 416);
  gtk_widget_set_usize (bt8, 54, 22);

  bt9 = gtk_button_new_with_label (blabels[8]);
  gtk_widget_ref (bt9);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "statio_9", bt9,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), bt9, 312, 416);
  gtk_widget_set_uposition (bt9, 312, 416);
  gtk_widget_set_usize (bt9, 54, 22);

  bt10 = gtk_button_new_with_label (blabels[9]);
  gtk_widget_ref (bt10);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_10", bt10,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), bt10, 376, 416);
  gtk_widget_set_uposition (bt10, 376, 416);
  gtk_widget_set_usize (bt10, 54, 22);

    gtk_signal_connect (GTK_OBJECT (bt1), "clicked",
                      GTK_SIGNAL_FUNC (on_station_1_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bt2), "clicked",
                      GTK_SIGNAL_FUNC (on_station_2_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bt3), "clicked",
                      GTK_SIGNAL_FUNC (on_station_3_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bt4), "clicked",
                      GTK_SIGNAL_FUNC (on_station_4_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bt5), "clicked",
                      GTK_SIGNAL_FUNC (on_station_5_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bt6), "clicked",
                      GTK_SIGNAL_FUNC (on_station_6_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bt7), "clicked",
                      GTK_SIGNAL_FUNC (on_station_7_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bt8), "clicked",
                      GTK_SIGNAL_FUNC (on_station_8_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bt9), "clicked",
                      GTK_SIGNAL_FUNC (on_statio_9_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bt10), "clicked",
                      GTK_SIGNAL_FUNC (on_station_10_clicked),
                      NULL);

  radplay = gtk_button_new_with_label ("Play");
  gtk_widget_ref (radplay);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "play_radio", radplay,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), radplay, 24, 386);
  gtk_widget_set_uposition (radplay, 24, 386);
  gtk_widget_set_usize (radplay, 54, 22);

  radstop = gtk_button_new_with_label ("Stop");
  gtk_widget_ref (radstop);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "stop_radio", radstop,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), radstop, 24, 410);
  gtk_widget_set_uposition (radstop, 24, 410);
  gtk_widget_set_usize (radstop, 54, 22);

  radprog = gtk_button_new_with_label ("Save");
  gtk_widget_ref (radprog);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "radio_program", radprog,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), radprog, 312, 446);
  gtk_widget_set_uposition (radprog, 312, 446);
  gtk_widget_set_usize (radprog, 54, 22);

  vt1 = gtk_vseparator_new ();
  gtk_widget_ref (vt1);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vseparator6", vt1,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), vt1, 432, 375);
  gtk_widget_set_uposition (vt1, 432, 375);
  gtk_widget_set_usize (vt1, 16, 105);

  vt2 = gtk_hseparator_new ();
  gtk_widget_ref (vt2);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "hseparator6", vt2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), vt2, 16, 472);
  gtk_widget_set_uposition (vt2, 16, 472);
  gtk_widget_set_usize (vt2, 424, 16);

  vt3 = gtk_vseparator_new ();
  gtk_widget_ref (vt3);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vseparator5", vt3,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), vt3, 8, 375);
  gtk_widget_set_uposition (vt3, 8, 375);
  gtk_widget_set_usize (vt3, 16, 105);

  vt4 = gtk_hseparator_new ();
  gtk_widget_ref (vt4);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "hseparator5", vt4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), vt4, 16, 368);
  gtk_widget_set_uposition (vt4, 16, 368);
  gtk_widget_set_usize (vt4, 424, 16);

  rlab = gtk_label_new ("FM Radio Player");
  gtk_widget_ref (rlab);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "label26", rlab,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), rlab, 8, 360);
  gtk_widget_set_uposition (rlab, 8, 360);
  gtk_widget_set_usize (rlab, 112, 16);

  freq_spin_adj = gtk_adjustment_new (frequencys[10],87.9,107.9, 0.1, 10, 10);
  freq_spin = gtk_spin_button_new (GTK_ADJUSTMENT (freq_spin_adj), 1, 1);
  gtk_widget_ref (freq_spin);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "freq_spin", freq_spin,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), freq_spin, 376, 446);
  gtk_widget_set_uposition (freq_spin, 376, 446);
  gtk_widget_set_usize (freq_spin, 56, 24);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (freq_spin), TRUE);

  flabel = gtk_label_new ("Station");
  gtk_widget_ref (flabel);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_lable", flabel,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), flabel, 16, 446);
  gtk_widget_set_uposition (flabel, 16, 446);
  gtk_widget_set_usize (flabel, 48, 24);

 gtk_signal_connect (GTK_OBJECT (radplay), "clicked",
                      GTK_SIGNAL_FUNC (on_play_radio_clicked),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (radstop), "clicked",
                      GTK_SIGNAL_FUNC (on_stop_radio_clicked),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (radprog), "clicked",
                      GTK_SIGNAL_FUNC (on_radio_program_clicked),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (freq_spin), "changed",
                      GTK_SIGNAL_FUNC (on_freq_spin_changed),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (freq_spin),"realize",
                      GTK_SIGNAL_FUNC (on_freq_spin_realize),
                      NULL);

  sadj=gtk_adjustment_new (frequencys[10]*10,879, 1079, 1, 0, 0);
  sta= gtk_hscale_new (GTK_ADJUSTMENT (sadj));
  gtk_widget_ref (sta);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vscale1", sta,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), sta, 63,446);
  gtk_widget_set_uposition (sta,63,446);
  gtk_widget_set_usize (sta,250,22);
  gtk_scale_set_draw_value (GTK_SCALE (sta), FALSE);


  gtk_signal_connect (GTK_OBJECT (sadj), "value_changed",
                        GTK_SIGNAL_FUNC (main_f), NULL);
stip=gtk_tooltips_new ();
sprintf(nb,"%-2.1f",frequencys[10]);
gtk_tooltips_set_tip((GtkTooltips*)stip,sta,nb,NULL);
gtk_tooltips_set_delay ((GtkTooltips*)stip,0);
*/
}





void
on_fixed3_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_save_radio_spin_changed             (GtkEditable     *editable,
                                        gpointer         user_data)
{
float fl=0;
char buf[1000];
unsigned long freq;

fl=gtk_spin_button_get_value_as_float((GtkSpinButton*)save_spin);
sprintf(buf,"%-2.1f",fl);

gtk_signal_handler_block_by_func((GtkObject *)sadj,main_f,NULL);
gtk_adjustment_set_value((GtkAdjustment *)sadj,atof(buf)*10);
gtk_signal_handler_unblock_by_func((GtkObject *)sadj,main_f,NULL);



gtk_signal_handler_block_by_func((GtkObject *)freq_spin,on_freq_spin_changed,NULL);
gtk_tooltips_set_tip((GtkTooltips*)stip,sta,buf,NULL);
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,atof(buf));
gtk_signal_handler_unblock_by_func((GtkObject*)freq_spin,on_freq_spin_changed,NULL);


if(radio_dev!=-1)
{
freq= ceil(atof(buf) * fact);

ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;/*tunevol;*/
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
}

}


void
on_save_radio_spin_realize             (GtkWidget       *widget,
                                        gpointer         user_data)
{
save_spin=widget;
gtk_spin_button_set_value ((GtkSpinButton*)widget,gtk_spin_button_get_value_as_float((GtkSpinButton*)freq_spin));
}


void
on_radio_save_exit_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(radsave_window);
gtk_main_quit();
}


void
on_radio_save_save_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
char b[1000];


if(rowsel>-1)
{
strcpy(b,gtk_entry_get_text((GtkEntry *)save_entry));
if(b[0]==0)
{
sprintf(b,"%d",rowsel+1);
}

gtk_clist_set_text((GtkCList *)save_list,rowsel,0,b);
strcpy(blabels[rowsel],b);

sprintf(b,"%-2.1f",gtk_spin_button_get_value_as_float((GtkSpinButton*)save_spin));
gtk_clist_set_text((GtkCList *)save_list,rowsel,1,b);
frequencys[rowsel]=atof(b);
do_save_config();
reset_radio_button(rowsel+1);
}

}




void
on_radio_save_window_realize           (GtkWidget       *widget,
                                        gpointer         user_data)
{
save_list=widget;
}



void
on_radio_save_list_select_row          (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
gtk_entry_set_text((GtkEntry *)save_entry,blabels[row]);
rowsel=row;

}


void
on_radio_save_list_realize             (GtkWidget       *widget,
                                        gpointer         user_data)
{
int n;
char *dat[3];
char r[1000];
rowsel=-1;
save_list=widget;

for(n=0;n<10;n++)
{
dat[0]=blabels[n];
sprintf(r,"%-2.1f",frequencys[n]);
dat[1]=r;
dat[2]=NULL;
gtk_clist_append((GtkCList *)save_list,dat);
}

}


void
on_radio_save_list_unselect_row        (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
gtk_entry_set_text((GtkEntry *)save_entry,"");
rowsel=-1;
}

