/*
Sonic Rainbow written by Gary Baker South Australia.
Copyright (C) 2003 Gary Baker

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "configs.h"

extern int destroy;
int isok;
int play_error=0;
int http_lookup=0;

extern int cd_autoplay,fm_autoplay;
extern int display_cd,display_ripper,display_ogg,display_mixer,fm_autoplay;
extern char *cd_dev,*music_dir;
extern int display_radio;
extern float frequencys[11];
extern char  blabels[11][7];
extern GtkWidget *setw;
extern int start_error;
extern GtkWidget *main_window_cd_autoplay;
extern int which_player;

GtkWidget *defplist;
GtkWidget *cdw,*rdw,*mdw;
GtkWidget *cdon,*cddisplay,*ripperdisplay,*oggdisplay,*mixerdisplay;
GtkWidget *playlistdir,*dpf,*play_direntry,*plistauto,*mixer_entry,*radio_entry;
GtkWidget *fm_auto,*playerror,*httplookup,*dv;
GtkWidget *mixer_win,*video_entry;
GtkWidget *ht,*radio_win;

char default_playlist_file[1000];
char default_playlist_dir[1000];
char default_mixer[1000];
char default_radio[1000];
char default_video[1000];
int plist_autoplay;
void do_save_config();



void
on_setup_window_destroy                (GtkObject       *object,
                                        gpointer         user_data)
{
 if(!destroy)
 {
  destroy=2;
  gtk_main_quit();
 }
}


void
on_setup_window_fixed_realize          (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_setup_window_exit_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
 destroy=2;
 gtk_main_quit();
}

void
on_setup_cd_device_entry_realize       (GtkWidget       *widget,
                                        gpointer         user_data)
{
cdw=widget;
if(!start_error)
gtk_entry_set_text((GtkEntry*)widget,cd_dev);
}


void
on_setup_window_cancel_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
 destroy=2;
 gtk_main_quit();
}


void
on_setup_window_defaults_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
 char *h,*b;
 int num;

 for(num=0;num<11;num++)
{
frequencys[num]=87.9;
sprintf(blabels[num],"%d",num+1);
}


 h=getenv("HOME");
 b=(char *)malloc(strlen(h)+22);
 strcpy(b,h);
 strcpy(default_playlist_dir,h);
 strcpy(default_video,h);
 strcpy(default_playlist_file,"");
 strcat(default_playlist_dir,"/sonic-rainbow/playlist/");
 strcat(default_video,"/sonic-rainbow/video/");
 strcat(b,"/sonic-rainbow/music/");
 gtk_entry_set_text((GtkEntry*)mdw,b);
 strcpy(default_mixer,"/dev/mixer");
 strcpy(default_radio,"/dev/radio");

/*set_defaults();*/


gtk_entry_set_text((GtkEntry*)defplist,default_playlist_file);
gtk_entry_set_text((GtkEntry*)play_direntry,default_playlist_dir);
gtk_entry_set_text((GtkEntry*)cdw,"/dev/cdrom");
gtk_entry_set_text((GtkEntry*)mixer_entry,default_mixer);
gtk_entry_set_text((GtkEntry*)play_direntry,default_playlist_dir);
gtk_entry_set_text((GtkEntry*)play_direntry,default_playlist_dir);
gtk_entry_set_text((GtkEntry*)radio_entry,default_radio);
gtk_entry_set_text((GtkEntry*)video_entry,default_video);

gtk_toggle_button_set_active((GtkToggleButton*)cdon,0);
gtk_toggle_button_set_active((GtkToggleButton*)plistauto,0);
gtk_toggle_button_set_active((GtkToggleButton*)fm_auto,0);
gtk_toggle_button_set_active((GtkToggleButton*)playerror,0);
gtk_toggle_button_set_active((GtkToggleButton*)httplookup,0);
free(b);
}


void
on_setup_window_help_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{

}




void
on_setup_music_directory_realize       (GtkWidget       *widget,
                                        gpointer         user_data)
{
mdw=widget;
if(!start_error)
gtk_entry_set_text((GtkEntry*)widget,music_dir);
else
music_dir=0;
}


void
on_setup_cd_autoplay_realize           (GtkWidget       *widget,
                                        gpointer         user_data)
{
cdon=widget;
gtk_toggle_button_set_active((GtkToggleButton*)widget,cd_autoplay);
}


void
on_setup_ogg_player_realize            (GtkWidget       *widget,
                                        gpointer         user_data)
{
oggdisplay=widget;
gtk_toggle_button_set_active((GtkToggleButton*)widget,display_ogg);
}


void
on_setup_ripper_window_realize         (GtkWidget       *widget,
                                        gpointer         user_data)
{
ripperdisplay=widget;
gtk_toggle_button_set_active((GtkToggleButton*)widget,display_ripper);
}


void
on_setup_mixer_window_realize          (GtkWidget       *widget,
                                        gpointer         user_data)
{
mixerdisplay=widget;
gtk_toggle_button_set_active((GtkToggleButton*)widget,display_mixer);
}


void
on_setup_cd_window_realize             (GtkWidget       *widget,
                                        gpointer         user_data)
{
cddisplay=widget;
gtk_toggle_button_set_active((GtkToggleButton*)widget,display_cd);
}



void
on_setup_window_apply_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
char b[1000];
FILE *fptr;
int num;

 cd_autoplay=gtk_toggle_button_get_active((GtkToggleButton*)cdon);

 if(main_window_cd_autoplay!=NULL)
gtk_toggle_button_set_active((GtkToggleButton*)main_window_cd_autoplay,gtk_toggle_button_get_active((GtkToggleButton*)cdon));

 plist_autoplay=gtk_toggle_button_get_active((GtkToggleButton*)plistauto);
 fm_autoplay=gtk_toggle_button_get_active((GtkToggleButton*)fm_auto);
 strcpy(default_playlist_file,gtk_entry_get_text((GtkEntry*)defplist));
 strcpy(default_playlist_dir,gtk_entry_get_text((GtkEntry*)play_direntry));
 strcpy(default_mixer,gtk_entry_get_text((GtkEntry*)mixer_entry));
 strcpy(default_video,gtk_entry_get_text((GtkEntry*)video_entry));
 strcpy(default_radio,gtk_entry_get_text((GtkEntry*)radio_entry));
 free(cd_dev);
 cd_dev=(char*)malloc(strlen(gtk_entry_get_text((GtkEntry*)cdw))+1);
 strcpy(cd_dev,gtk_entry_get_text((GtkEntry*)cdw));
 play_error=gtk_toggle_button_get_active((GtkToggleButton*)playerror);
 http_lookup=gtk_toggle_button_get_active((GtkToggleButton*)httplookup);

 free(music_dir);
 music_dir=(char*)malloc(strlen(gtk_entry_get_text((GtkEntry*)mdw))+2);
 strcpy(music_dir,gtk_entry_get_text((GtkEntry*)mdw));
 if(music_dir[0]!=0)
 {
 if(music_dir[strlen(music_dir)-1]!='/')
 strcat(music_dir,"/");
 }
 if(default_playlist_dir[0]!=0)
 {
 if(default_playlist_dir[strlen(default_playlist_dir)-1]!='/')
 strcat(default_playlist_dir,"/");
 }

 sprintf(b,"%s/sonic-rainbow",getenv("HOME"));
 mkdir(b,S_IRWXU|S_IRWXG|S_IRWXO);
 strcat(b,"/sr.config");

 fptr=fopen(b,"wb");
 fprintf(fptr,"%s\n%s\n",cd_dev,music_dir);
 fprintf(fptr,"%d %d %d %d %d %d %d\n",cd_autoplay,display_cd,display_ripper,plist_autoplay,display_mixer,play_error,http_lookup);
 fprintf(fptr,"%s\n",default_playlist_file);
 fprintf(fptr,"%s\n",default_playlist_dir);
 fprintf(fptr,"%s %s\n",default_mixer,default_video);
 fprintf(fptr,"%s %d\n",default_radio,which_player);
  for(num=0;num<11;num++)
 {
  fprintf(fptr,"%-2.1f %s\n",frequencys[num],blabels[num]);
 }
 fprintf(fptr,"%d\n",fm_autoplay);
 fclose(fptr);

 if(!start_error)
 {
 /*
 if(!display_radio)hide_radio();
 else
 show_radio();
 */
 }
}

void
on_setup_cd_player_browse_clicked      (GtkButton       *button,
                                        gpointer         user_data)
{
GtkWidget *f;
char b[1000];
 f=create_setup_cd_browsefile ();
 gtk_widget_show(f);
 gtk_main();
if(isok)
{
 strcpy(b,gtk_file_selection_get_filename ((GtkFileSelection *)f));
 if(b[strlen(b)-1]!='/')
 {
  gtk_entry_set_text((GtkEntry*)cdw,b);
 }
}

 gtk_widget_destroy(f);
}


void
on_setup_cd_browsefile_ok_clicked      (GtkButton       *button,
                                        gpointer         user_data)
{
isok=1;
gtk_main_quit();
}


void
on_setup_cd_browsefile_cancel_clicked  (GtkButton       *button,
                                        gpointer         user_data)
{
isok=0;
gtk_main_quit();
}




void
on_setup_music_directory_browse_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
GtkWidget *f;
char b[1000];
 f=create_setup_window_music_browsefile ();
 gtk_widget_show(f);
 gtk_main();
if(isok)
{
 strcpy(b,gtk_file_selection_get_filename ((GtkFileSelection *)f));
 if(b[strlen(b)-1]=='/')
 {
  gtk_entry_set_text((GtkEntry*)mdw,b);
 }
}

 gtk_widget_destroy(f);
}


void
on_setup_music_browsefile_ok_clicked   (GtkButton       *button,
                                        gpointer         user_data)
{
isok=1;
gtk_main_quit();
}


void
on_setup_music_browsefile_cancel_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
isok=0;
gtk_main_quit();
}

void
on_setup_playlist_dirbrowse_button_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
playlistdir=create_setup_playlist_browsedir_window();
gtk_file_selection_set_filename ((GtkFileSelection *)playlistdir,default_playlist_dir);
gtk_widget_show(playlistdir);
}


void
on_setup_playlist_direntry_realize     (GtkWidget       *widget,
                                        gpointer         user_data)
{
play_direntry=widget;
if(!start_error)
gtk_entry_set_text((GtkEntry*)play_direntry,default_playlist_dir);
}


void
on_setup_default_playlist_entry_realize
                                        (GtkWidget       *widget,
                                        gpointer         user_data)
{
defplist=widget;
if(!start_error)
gtk_entry_set_text((GtkEntry*)defplist,default_playlist_file);
}


void
on_setup_default_playlist_browsebutton_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
dpf=create_setup_select_defaultplaylist_file_window();
gtk_file_selection_set_filename ((GtkFileSelection *)dpf,default_playlist_dir);
gtk_widget_show(dpf);
}


void
on_setup_playlist_autoplay_realize     (GtkWidget       *widget,
                                        gpointer         user_data)
{
plistauto=widget;
gtk_toggle_button_set_active((GtkToggleButton*)widget,plist_autoplay);
}


void
on_setup_create_playlistonrip_realize  (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_setup_playlist_browsedir_ok_clicked (GtkButton       *button,
                                        gpointer         user_data)
{
char *e;

e=gtk_file_selection_get_filename ((GtkFileSelection *)playlistdir);
if(e[strlen(e)-1]!='/')return;
gtk_entry_set_text((GtkEntry*)play_direntry,e);
gtk_widget_destroy(playlistdir);
}


void
on_setup_playlist_browsedir_cancel_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(playlistdir);
}

void
on_setup_defaultPlaylist_file_ok_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
char *e;
e=gtk_file_selection_get_filename ((GtkFileSelection *)dpf);
if(e[strlen(e)-1]=='/')return;
gtk_entry_set_text((GtkEntry*)defplist,e);
gtk_widget_destroy(dpf);
}


void
on_setup_default_playlist_file_cancel_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(dpf);
}


void
on_setup_mixer_entry_realize           (GtkWidget       *widget,
                                        gpointer         user_data)
{
mixer_entry=widget;
if(!start_error)
gtk_entry_set_text((GtkEntry*)mixer_entry,default_mixer);
}


void
on_setup_mixer_browse_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
mixer_win=create_setup_select_mixer_window();
gtk_widget_show(mixer_win);
}


void
on_select_mixer_ok_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_entry_set_text((GtkEntry*)mixer_entry,gtk_file_selection_get_filename ((GtkFileSelection *)mixer_win));
gtk_widget_destroy(mixer_win);
}


void
on_select_mixer_cancel_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(mixer_win);
}


void
on_radio_dev_entry_realize             (GtkWidget       *widget,
                                        gpointer         user_data)
{
radio_entry=widget;
if(!start_error)
gtk_entry_set_text((GtkEntry*)radio_entry,default_radio);
}


void
on_radio_browse_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
radio_win=create_select_window_radio_browse();
gtk_widget_show(radio_win);
}




void do_save_config()
{
char b[1000];
FILE *fptr;
int num;


 sprintf(b,"%s/sonic-rainbow",getenv("HOME"));
 mkdir(b,S_IRWXU|S_IRWXG|S_IRWXO);
 strcat(b,"/sr.config");

 fptr=fopen(b,"wb");
 fprintf(fptr,"%s\n%s\n",cd_dev,music_dir);
 fprintf(fptr,"%d %d %d %d %d %d %d\n",cd_autoplay,display_cd,display_ripper,plist_autoplay,display_mixer,play_error,http_lookup);
 fprintf(fptr,"%s\n",default_playlist_file);
 fprintf(fptr,"%s\n",default_playlist_dir);
 fprintf(fptr,"%s %s\n",default_mixer,default_video);
 fprintf(fptr,"%s %d\n",default_radio,which_player);
  for(num=0;num<11;num++)
 {
  fprintf(fptr,"%-2.1f %s\n",frequencys[num],blabels[num]);
 }
fprintf(fptr,"%d\n",fm_autoplay);
 fclose(fptr);

}


void
on_setup_fm_autoplay_realize           (GtkWidget       *widget,
                                        gpointer         user_data)
{
fm_auto=widget;
gtk_toggle_button_set_active((GtkToggleButton*)widget,fm_autoplay);
}

void
on_play_error_enable_realize           (GtkWidget       *widget,
                                        gpointer         user_data)
{
playerror=widget;
gtk_toggle_button_set_active((GtkToggleButton*)widget,play_error);
}


void
on_http_lookup_realize                 (GtkWidget       *widget,
                                        gpointer         user_data)
{
httplookup=widget;
gtk_toggle_button_set_active((GtkToggleButton*)widget,http_lookup);
}


void
on_setup_default_video_entry_realize   (GtkWidget       *widget,
                                        gpointer         user_data)
{
video_entry=widget;
gtk_entry_set_text((GtkEntry*)widget,default_video);
}


void
on_setup_default_video_browsebutton_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
dv=create_setup_video_browse();
gtk_file_selection_set_filename ((GtkFileSelection *)dv,default_video);
gtk_widget_show(dv);
}

void
on_video_browse_ok_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
char *e;

e=gtk_file_selection_get_filename ((GtkFileSelection *)dv);
if(e[strlen(e)-1]!='/')return;
gtk_entry_set_text((GtkEntry*)video_entry,e);
gtk_widget_destroy(dv);
}


void
on_video_browse_cancel_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(dv);
}



void
on_setup_radio_ok_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
char *e;

e=gtk_file_selection_get_filename ((GtkFileSelection *)radio_win);
if(e[strlen(e)-1]=='/')return;
gtk_entry_set_text((GtkEntry*)radio_entry,e);
gtk_widget_destroy(radio_win);
}


void
on_setup_radio_cancel_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(radio_win);
}


